package Krabb;
import java.awt.geom.*;
import java.lang.Math.*;

public class Vector2D
{
	double x,y;
	public Vector2D()
	{
		this.x=0;
		this.y=0;
	}
	
	public Vector2D(Vector2D v)
	{
		this.x=v.x;
		this.y=v.y;
	}
	
	public Vector2D(Point2D p)
	{
		this.x=p.getX();
		this.y=p.getY();
	}
	
	public Vector2D(double a, double l)
	{
		this.x=Math.sin(a)*l;
		this.y=Math.cos(a)*l;
	}	
	
	public Point2D.Double getPoint(){
		return new Point2D.Double(x,y);}

	public double getX()
	{
		return x;	
	}
	
	public double getY()
	{
		return y;	
	}
	
	public Vector2D Add(Vector2D v)
	{
		Vector2D w=new Vector2D(this);
		w.x+=v.x;	
		w.y+=v.y;
		return w;
	}
	
	public Vector2D Subtract(Vector2D v)
	{
		Vector2D w=new Vector2D(this);
		w.x-=v.x;
		w.y-=v.y;
		return w;
	}
	
	public double Dot(Vector2D v)
	{
		return x*v.x + y*v.y;
	}
	
	public Vector2D Multiplicate(double a)
	{
		Vector2D w=new Vector2D(this);
		w.x*=a;
		w.y*=a;
		return w;
	}
	
	public double Length()
	{
		return Math.sqrt(x*x+y*y);		
	}
	
	public double getA()
	{
		return (Math.PI/2-Math.atan2(y,x));
	}
	
	public Vector2D Normalize()
	{
		Vector2D w=new Vector2D(this);
		double l=Length();
		if(l==0)
		{
			w.x=0;
			w.y=0;
			return w;
		}
		w.x/=l;
		w.y/=l;
		return w;
	}
}