package Krabb.krabby2;
import Krabb.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.*;
import java.awt.geom.Point2D;
import java.util.*;

class Enemy extends Constants
{
	private ArrayList estats = new ArrayList();
	private ArrayList ewaves = new ArrayList();
	private static int hits,shots,misses;
	private boolean alive=true;
	private double lastv=0;
	double lastgf=0;
	double llastgf=0;
	double heat=0;
	public long scaned=-1;
	
	public void run()
	{
		scaned=-1;	
		super.run();
		
	}
	
	public void Step()
	{
		heat-=0.1;
		int size=ewaves.size();
		for(Iterator i = ewaves.iterator(); i.hasNext();)
		{
			Wave w = (Wave)i.next();
			if(w.v*(getTime()-w.t)>1000)
			{
				ewaves.remove(i);
				misses++;
			}
		}
	}
	
	public int getShots(){
		return shots;}
	public int getHits(){
		return hits;}
	
	public Stats getEnemyStats()
	{
		if(!estats.isEmpty())
			return (Stats) estats.get(0);
		else
			return null;	
	}
	
	public Stats getEnemyStats(int i)
	{
		if(estats.size()>i)
			return (Stats) estats.get(i);
		else
			return null;	
	}
	
	public Stats getEnemyTimeStats(long t)
	{
		if(estats.size()==0)
			return null;
		Stats en;
		for(int i=0; i<100 && i<estats.size(); i++)
		{		
			en = (Stats) estats.get(i);
			if(en.time<=t)
				return en;
		}
		return (Stats) estats.get(estats.size()-1);
	}

	
	public Wave getEnemyWave(int i)
	{
		if(ewaves.size()>i)
			return (Wave) ewaves.get(i);
		else
		{
			System.out.println("No wave at"+i+" !");
			return (Wave) ewaves.get(ewaves.size()-1);
		}
	}		
	
	int getLastEnemyShot()
	{
		Wave w;
		// Finde letzten
		double lasttime=0;
		int last=0;
		double d,dx,dy;
		for(int n=0; n<ewaves.size(); n++)
		{
			w=getEnemyWave(n);
			if(w.d/w.v<(getTime()-w.t))	//Wenn hinter Robot
				continue;
			d=w.t+w.d/w.v;
			//Als letztes geschossen
			if(d>lasttime)
			{
				lasttime=d;
				last=n;
			}
		}
		return last;
	}
	
	int getFirstEnemyShot()
	{
		double smallesttime=999999;
		int smallest=-1;	
		Wave w;
		// Finde ersten
		double d,dx,dy;
		for(int n=0; n<ewaves.size(); n++)
		{
			w=getEnemyWave(n);
			if(w.moved)
				continue;
			if(w.hit)
				continue;
			d=w.t+w.d/w.v;
			//Smalles hit time
			if(d<smallesttime)
			{
				smallesttime=d;
				smallest=n;
			}
		}
		return smallest;
	}
	
	int getFirstMoveShot()
	{
		double smallesttime=999999;
		int smallest=-1;	
		Wave w;
		// Finde ersten
		double d,dx,dy;
		for(int n=0; n<ewaves.size(); n++)
		{
			w=getEnemyWave(n);
			if(w.moved)
				continue;
			d=w.t+w.d/w.v;
			//Smalles hit time
			if(d<smallesttime)
			{
				smallesttime=d;
				smallest=n;
			}
		}
		return smallest;
	}
	
	int getSecondMoveShot()
	{
		int first=getFirstMoveShot();
		double smallesttime=999999;
		int smallest=-1;	
		Wave w;
		// Finde ersten
		double d,dx,dy;
		for(int n=0; n<ewaves.size(); n++)
		{
			w=getEnemyWave(n);
			if(w.moved || first==n)
				continue;
			d=w.t+w.d/w.v;
			//Smalles hit time
			if(d<smallesttime)
			{
				smallesttime=d;
				smallest=n;
			}
		}
		return smallest;
	}	

	
	public void newEnemyGF(double gf){
		llastgf=lastgf;
		lastgf=gf;
		
	}
	
	public boolean isAlive(){
		return alive;}
	
	public int getEnemyWaveSize(){
		return ewaves.size();}
	
	public int getEnemySize(){
		return estats.size();}
	
	public void onScannedRobot(ScannedRobotEvent e)
	{
		if(estats.size()==0 ||((Stats)estats.get(0)).time<getTime())
			estats.add(0,new Stats(e,this));
	
		if(scaned==-1)
		{
			scaned=getTime();
			return;
		}
		Stats e0 = getEnemyStats(0);
		Stats e1 = getEnemyStats(1);
		double p=e1.l-e0.l;
		if(heat<=1 && p>0)
		{
			if(p>=0.09 && p<=3.)
			{
				shots++;
				heat=1 + (p / 5);
				ewaves.add(0,new Wave(this,e1,p));
			}
		}
		if(lastv*e.getVelocity()<=0)
			getEnemyStats().lchange=getTime();
		lastv=e.getVelocity();
		super.onScannedRobot(e);
	}
	
	public void onBulletHit(BulletHitEvent e)
	{
		double p=e.getBullet().getPower();
		double dmg=4*p + 2*Math.max(p-1,0);
		getEnemyStats().l-=dmg;
	}
	
	public void onHitByBullet(HitByBulletEvent e)
	{
		hits++;
		getEnemyStats().l+=e.getBullet().getPower()*3;
	}
		
	public void onRobotDeath(RobotDeathEvent e)
	{
		alive=false;
		((Stats)estats.get(0)).l=-2;
	}
	
	public void onPaint(java.awt.Graphics2D g)
	{
		double hitrate,hitrate2;
		if(hits==0)
			hitrate=0;
		else
			hitrate=hits/((double)(shots)/100.0);
		if(hits==0)
			hitrate2=0;
		else
			hitrate2=hits/((double)(misses)/100.0);
		g.setColor(Color.blue);
		g.drawString("His Rate:  Hits:"+hits+" Schots:"+shots+" Hitrate: "+hitrate+"%"+"  HitrateB: "+hitrate2,300,20);
		for(int i=0; i<ewaves.size(); i++)		
			((Wave)ewaves.get(i)).onPaint(g,this);
		if(scaned!=-1)
			getEnemyStats().onPaint(g);
		g.drawString("lastGF: "+lastgf,300,30);
	}
}
