package Krabb.krabby2;
import Krabb.*;
import java.awt.geom.Point2D;
import robocode.*;
import java.util.*;
import java.io.*;
import java.awt.*;
import robocode.util.Utils;

public class Gun extends Scan
{
	private static Statistics statistics = new Statistics(NRIFLES);
	private Rifle rifle[] = new Rifle[NRIFLES];
	Aim bestaim = new Aim(0,0);
	public Gun()
	{
		rifle[0] = new GuessFactor(0);
		rifle[1] = new GuessFactor(-1.0);
		rifle[2] = new GuessFactor(-0.9);
		rifle[3] = new GuessFactor(-0.8);
		rifle[4] = new GuessFactor(-0.7);
		rifle[5] = new GuessFactor(-0.6);
		rifle[6] = new GuessFactor(-0.5);
		rifle[7] = new GuessFactor(-0.4);
		rifle[8] = new GuessFactor(-0.3);
		rifle[9] = new GuessFactor(-0.2);
		rifle[10] = new GuessFactor(-0.1);
		rifle[11] = new GuessFactor(0.1);
		rifle[12] = new GuessFactor(0.2);
		rifle[13] = new GuessFactor(0.3);
		rifle[14] = new GuessFactor(0.4);
		rifle[15] = new GuessFactor(0.5);
		rifle[16] = new GuessFactor(0.6);
		rifle[17] = new GuessFactor(0.7);
		rifle[18] = new GuessFactor(0.8);
		rifle[19] = new GuessFactor(0.9);
		rifle[20] = new GuessFactor(1);		
/*
		rifle[21] = new GuessFactor(-1.0);
		rifle[22] = new GuessFactor(-0.95);
		rifle[23] = new GuessFactor(-0.85);
		rifle[24] = new GuessFactor(-0.75);
		rifle[25] = new GuessFactor(-0.65);
		rifle[26] = new GuessFactor(-0.55);
		rifle[27] = new GuessFactor(-0.45);
		rifle[28] = new GuessFactor(-0.35);
		rifle[29] = new GuessFactor(-0.25);
		rifle[30] = new GuessFactor(-0.15);
		rifle[31] = new GuessFactor(0.15);
		rifle[32] = new GuessFactor(0.25);
		rifle[33] = new GuessFactor(0.35);
		rifle[34] = new GuessFactor(0.45);
		rifle[35] = new GuessFactor(0.55);
		rifle[36] = new GuessFactor(0.65);
		rifle[37] = new GuessFactor(0.75);
		rifle[38] = new GuessFactor(0.85);
		rifle[39] = new GuessFactor(0.95);
		rifle[40] = new GuessFactor(1);		
		rifle[41] = new GuessFactor(-0.05);
		rifle[42] = new GuessFactor(0.05);
*/				
				
		rifle[21] = new Linear();
		rifle[22] = new Circular();
	}
	
	public void run() {
		super.run();
		setAdjustGunForRobotTurn(true);
	}
			
	public void Step()
	{
		super.Step();
		if(scaned==-1)
			return;
		Stats e=getEnemyStats();
		double p = setPower();
		if(getGunHeat()<0.5 && getGunHeat()>0.2 )
		{
			bestaim = statistics.getBestAim(new Wave(p,this),this,true,(long)(getGunHeat()*10));
		}
		double a = rifle[bestaim.rifle].Aim(this,p,getTime());
		setTurnGunRightRadians(Utils.normalRelativeAngle(a-getGunHeadingRadians()));
		if(getGunHeat()==0 && e.l>=0 && getEnergy()>0.1 && isAlive() && (!MC || (getFirstEnemyShot()==-1 && getEnemyStats().l<0.000000001)))// && p<getEnergy()
		{
			setFireBullet(p);
			statistics.newShot(getMateWave(0),this);
		}
		checkHit();
	}
	
	private void checkHit()
	{
		for(int i=0; i<getNumMateWaves(); i++)
		{
			Wave w = getMateWave(i);
			double radius;
			double d;
			Stats e = getEnemyStats();
			radius=w.v*(getTime()-w.t);
			Vector2D newe= e.p;//.Add(e.v.Multiplicate(getTime()-e.time));
			d=newe.Subtract(w.p).Length();
			//Wenn Wave Kollidiert:
//			System.out.println(radius +"  "+d+"  "+w.hit);
			if(radius>=d && !w.hit)
			{
				e = getEnemyStats();
				double ad,a,aim;	//delta a,a
				ad=Math.atan(18/radius);
				a=e.p.Subtract(w.p).getA();
				boolean[] hit= new boolean[NRIFLES];
				for(int x=0; x<NRIFLES; x++)
				{
					aim=rifle[x].Aim(this,w.pow,w.t);
					if(aim>a-ad && aim<a+ad)
					{
						hit[x]=true;
					}
				}
				statistics.newHit(hit,w,this);
				newEnemyGF(getGF(w.pow,w.t));
				w.hit=true;
			}
		}
	}
	
	private double getGF(double p, double time)
	{
		if(getEnemySize()==0)
			return 0;
		Stats e=getEnemyTimeStats((int)time);
		Stats thise = getEnemyStats();
		Stats m=getMateTimeStats((int)time);
		Vector2D aim=e.p.Subtract(m.p);
//		double t=aim.Length()/(20.0 - 3.0 * p);
		double v=(20.0 - 3.0 * p);
		double maxa=Math.asin(8/v);
//		double max=(t*8);
		double a=e.p.Subtract(m.p).getA()-thise.p.Subtract(m.p).getA();
//		double done = Math.sin(e.p.Subtract(m.p).getA()-e.p.Subtract(thise.p).getA())*e.p.Subtract(thise.p).Length();
//		if(done!=0)
//			return done/max;
//		else
//			return 0;
		return a/maxa;
	}
	
	public void onScannedRobot(ScannedRobotEvent e)
	{
		super.onScannedRobot(e);
	}
	
	private double setPower()
	{
		double p;
		double d=getEnemyStats().p.Subtract(getMateStats().p).Length();
		p=Math.max(0.1,Math.min(3,(-0.0045*d+4)));
//		p=Math.min(getEnergy()/3,p);
		if(TC)
			return Math.min(3.0,getEnergy());
		p= Math.min((getEnemyStats().l)/4,p);//+0.1
		p= Math.min(p,getEnergy());
		return Math.max(0.1,p);
	}

	public void onPaint(java.awt.Graphics2D g)
	{
		super.onPaint(g);
		double bullet[] = new double[NRIFLES];
		int x,x1,y,y1;
		double radius = 400;
		g.setColor(Color.blue);
		g.drawString("Best Chance: "+bestaim.chance,300,40);
		g.drawString("Best Rifle: "+bestaim.rifle+"  Shots: "+bestaim.shots+"  con1: "+bestaim.con1+"  con2: "+bestaim.con2,300,50);
/*
		for(int i=0; i<NRIFLES; i++)
		{
			bullet[i]=rifle[i].Aim(this,setPower(),getTime());
			x=(int)getX();
			y=(int)(getBattleFieldHeight()-getY());
			x1=(int)(getX()+Math.sin(bullet[i])*radius);
			y1=(int)(getBattleFieldHeight()-(getY()+Math.cos(bullet[i])*radius));
			g.drawLine(x, y, x1, y1);
		}
*/
	}	
}

abstract class Rifle
{
	abstract double Aim(Gun g, double p, double t);
}

class Linear extends Rifle
{
	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats s=g.getMateTimeStats((int)time);
		Vector2D newp = e.p;
		double t=0;
		for (int i = 0; i < 6; i++)
		{
			t=newp.Subtract(s.p).Length()/(20.0-3.0*p)+s.time-e.time;
			newp = e.p.Add(e.v.Multiplicate(t));
		}
		return newp.Subtract(s.p).getA();
	}
}

class LinearGF extends Rifle
{
	double gf;
	LinearGF(double gf)
	{
		this.gf=gf;
	}

	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats s=g.getMateTimeStats((int)time);
		Vector2D newp = e.p;
		double t=0;
		double v=0;
		for(int i=0; i<15 && v==0; i++)
		{
			e=g.getEnemyTimeStats((int)time-i);
			v=e.v.Length();
		}
		for (int i = 0; i < 6; i++)
		{
			t=newp.Subtract(s.p).Length()/(20.0-3.0*p)+s.time-e.time;
			newp = e.p.Add(e.v.Multiplicate(t*gf*8/v));
		}
		return newp.Subtract(s.p).getA();
	}
}

class Acceleration extends Rifle
{
	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats e1=g.getEnemyTimeStats((int)time-3);
		Stats s=g.getMateTimeStats((int)time);
		Vector2D newp = e.p;
		double t=0;
		Vector2D ace = e.v.Subtract(e1.v).Multiplicate(1/(Math.max(1,e1.time-e.time)));
		for (int i = 0; i < 6; i++)
		{
			t=newp.Subtract(s.p).Length()/(20.0-3.0*p)+s.time-e.time;;
			newp = e.p.Add(ace.Multiplicate(t*t*0.5));//.Add(e.v.Multiplicate(t))
		}
		return newp.Subtract(s.p).getA();
	}
}

class Circular extends Rifle
{
	Linear linear = new Linear();
	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats ea=g.getEnemyTimeStats(((int)time)-5);
		Stats s=g.getMateTimeStats((int)time);
		double hv=(e.v.getA()-ea.v.getA())/(e.time-ea.time);
  		if (hv == 0)
		{
			return linear.Aim(g,p,time);
		}
		Vector2D newp = e.p;
		//Berechne Differenz:
		double d,t;
		for (int i = 0; i < 10; i++)
		{
			d = newp.Subtract(s.p).Length();
			t=d/(20.0 - 3.0 * p)+s.time-e.time;
       		double radius = e.v.Length()/hv;
        	double tothead = t * hv;
			double heading = e.v.getA();
			double newY= e.p.getY() + (Math.sin(heading + tothead) * radius) - (Math.sin(heading) * radius);
			double newX= e.p.getX() + (Math.cos(heading) * radius) - (Math.cos(heading + tothead) * radius);
			newp = new Vector2D(new Point2D.Double(newX,newY));
   		}
//		System.out.println("hv:"+hv+" a:"+newp.Subtract(s.p).getA()+" "+e.time+" "+ea.time+" "+(e.time-ea.time)+" "+g.getTime()+" "+time);	
		return newp.Subtract(s.p).getA();
	}
}

class Random extends Rifle
{
	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats m=g.getMateTimeStats((int)time);
		Vector2D aim=e.p.Subtract(m.p);
		double t=aim.Length()/(20.0 - 3.0 * p);
		double maxa=((t*8)/aim.Length());	
		return aim.getA()+Math.random()*maxa-Math.random()*maxa;
	}
}

class GuessFactor extends Rifle
{
	double gf;
	GuessFactor(double gf)
	{
		this.gf=gf;
	}
	
	double Aim(Gun g, double p, double time)
	{
		if(g.getEnemySize()==0)
			return 0;
		Stats e=g.getEnemyTimeStats((int)time);
		Stats m=g.getMateTimeStats((int)time);
		Vector2D aim=e.p.Subtract(m.p);
		double da=m.p.Subtract(e.p).getA()-m.p.Subtract(e.p).Add(e.v).getA();	//delta a
		if(da==0)
		{
			da=1;
		}
		double ada=Math.abs(da)/da;			//abs(da)
		double v=(20.0 - 3.0 * p);
//		double t=aim.Length()/v;
		double maxa=Math.asin(8/v);//
//		double maxa = ((t*8)/aim.Length());
		return aim.getA()+gf*maxa*ada;		
	}
}
