// $Id: Statistics.java,v 1.7 2005/06/04 22:55:46 helge Exp $

package Krabb.krabby2;
import robocode.*;
import java.io.*;
import Krabb.*;
import java.util.zip.*;
import java.lang.String.*;
import java.awt.*;
import java.awt.geom.*;
import robocode.util.Utils;

public class Statistics
{
	private int nconditions=59;
	private int ndistances=3;
	private int nwdistances=2;
	private Condition condition[];
	private Condition distcon[];
	private Condition wdistcon[];
	private HitChance hitchance[][][][];
	private int currentgun=0;
	private double currentchance=0;
	private int NRIFLES;
	private long deltat=4;
	
	public Statistics(int NRS)
	{
		NRIFLES=NRS;
		condition = new Condition[nconditions];
		distcon = new Condition[ndistances];
		wdistcon = new Condition[nwdistances];
		hitchance = new HitChance[nwdistances][ndistances][nconditions][nconditions];
		for(int j=0; j<nconditions; j++)
			for(int k=0; k<nconditions; k++)
				for(int i=0; i<ndistances; i++)
					for(int l=0; l<nwdistances; l++)
						hitchance[l][i][k][j] = new HitChance(NRIFLES);
		distcon[0] = new ConDistance(0,150);
		distcon[1] = new ConDistance(150,400);
		distcon[2] = new ConDistance(400,9999999);
		wdistcon[0] = new ConWDistance(0,100);
		wdistcon[1] = new ConWDistance(100,999999);
								
		int i=0;

		condition[i++] = new ConLateralV(-2,0);
		condition[i++] = new ConLateralV(-4,-2);
		condition[i++] = new ConLateralV(-6,-4);
		condition[i++] = new ConLateralV(-8,-6);
		condition[i++] = new ConLateralV(0,2);
		condition[i++] = new ConLateralV(2,4);
		condition[i++] = new ConLateralV(4,6);
		condition[i++] = new ConLateralV(6,8);

		condition[i++] = new ConLateralAV(0,2);
		condition[i++] = new ConLateralAV(2,4);
		condition[i++] = new ConLateralAV(4,6);
		condition[i++] = new ConLateralAV(6,8);
		condition[i++] = new ConPower(0,1);
		condition[i++] = new ConPower(1,2);
		condition[i++] = new ConPower(2,3);
		condition[i++] = new ConCorner(0,150);
		condition[i++] = new ConCorner(150,200);
		condition[i++] = new ConWall(0,30);
		condition[i++] = new ConWall(30,120);
		condition[i++] = new ConWall(30,120);
		condition[i++] = new ConDWall(0,50);
		condition[i++] = new ConDWall(-50,0);
		condition[i++] = new ConLastChange(0,10);
		condition[i++] = new ConLastChange(10,20);
		condition[i++] = new ConLastChange(20,30);
		condition[i++] = new ConLastChange(30,40);
		condition[i++] = new ConLastChange(50,60);
		condition[i++] = new ConLastChange(60,100);
		condition[i++] = new ConBearing(0,Math.PI/4);
		condition[i++] = new ConBearing(Math.PI/4,Math.PI*2/4);
		condition[i++] = new ConBearing(Math.PI*2/4,Math.PI*3/4);
		condition[i++] = new ConBearing(Math.PI*3/4,Math.PI);
		condition[i++] = new ConBearing(-Math.PI/4,0);
		condition[i++] = new ConBearing(-Math.PI*2/4,-Math.PI/4);
		condition[i++] = new ConBearing(-Math.PI*3/4,-Math.PI*2/4);
		condition[i++] = new ConBearing(-Math.PI,-Math.PI*3/4);
		condition[i++] = new ConLastGF(-1,-0.8);
		condition[i++] = new ConLastGF(-0.8,-0.6);		
		condition[i++] = new ConLastGF(-0.6,-0.4);		
		condition[i++] = new ConLastGF(-0.4,-0.2);		
		condition[i++] = new ConLastGF(-0.2,0);		
		condition[i++] = new ConLastGF(0.8,1);
		condition[i++] = new ConLastGF(0.6,0.8);		
		condition[i++] = new ConLastGF(0.4,0.6);		
		condition[i++] = new ConLastGF(0.2,0.4);		
		condition[i++] = new ConLastGF(0,0.2);
		condition[i++] = new ConVelocity(0,1);	
		condition[i++] = new ConVelocity(1,2);	
		condition[i++] = new ConVelocity(2,3);	
		condition[i++] = new ConVelocity(3,4);	
		condition[i++] = new ConVelocity(4,5);	
		condition[i++] = new ConVelocity(5,6);	
		condition[i++] = new ConVelocity(6,7);	
		condition[i++] = new ConVelocity(7,8);
		condition[i++] = new ConAcceleration(-1,1);	
		condition[i++] = new ConAcceleration(-5,-1);	
		condition[i++] = new ConAcceleration(-99,-5);	
		condition[i++] = new ConAcceleration(1,5);	
		condition[i++] = new ConAcceleration(5,99);	
/*
		condition[i++] = new ConLateralV(0,8);
		condition[i++] = new ConLateralV(-8,0);		
		condition[i++] = new ConAcceleration(-999,0);
		condition[i++] = new ConAcceleration(0,999);
		condition[i++] = new ConBearing(0,Math.PI);
		condition[i++] = new ConBearing(Math.PI,Math.PI);
		condition[i++] = new ConBearing(0,Math.PI);
		condition[i++] = new ConBearing(0,Math.PI);
		condition[i++] = new ConVelocity(0,4);	
		condition[i++] = new ConVelocity(4,9);	
		condition[i++] = new ConLastGF(3,0);
		condition[i++] = new ConLastGF(0,3);
*/						
																		
}
	
	public void newShot(Wave w, Gun g)
	{
//		System.out.println("new Shot");
		for(int l=0; l<nwdistances; l++)
			if(wdistcon[l].isTrue(w,g,deltat))
		for(int d=0; d<ndistances; d++)
			if(distcon[d].isTrue(w,g,deltat))
				for(int k=0; k<nconditions; k++)
					if(condition[k].isTrue(w,g,deltat))
						for(int i=0; i<nconditions; i++)
							if(condition[i].isTrue(w,g,deltat))
							{
								hitchance[l][d][k][i].newShot();
//								hitchance[k][i].newChance();
							}
	}
	
	public void newHit(boolean hits[], Wave w, Gun g)
	{
//		System.out.println("new Hit"+nrifle);
		for(int l=0; l<nwdistances; l++)
		{
			if(!wdistcon[l].isTrue(w,g,deltat))
				continue;
		for(int d=0; d<ndistances; d++)
		{
			if(!distcon[d].isTrue(w,g,deltat))
				continue;
			for(int k=0; k<nconditions; k++)
			{
				if(!condition[k].isTrue(w,g,deltat))
					continue;
				for(int i=0; i<nconditions; i++)
				{
					if(condition[i].isTrue(w,g,deltat))
					{
						hitchance[l][d][k][i].newHit(hits);
						hitchance[l][d][k][i].newChance();
					}
				}
			}
		}
		}
	}

	public Aim getBestAim(Wave w, Gun g, boolean rolling, long dt)
	{
		double current,best=0;
		int bestgun=0;
		int shots=0;
		int c1=0,c2=0;
		for(int l=0; l<nwdistances; l++)
		{
			if(!wdistcon[l].isTrue(w,g,deltat-dt))
				continue;
		for(int d=0; d<ndistances; d++)
		{
			if(!distcon[d].isTrue(w,g,deltat-dt))
				continue;
			for(int k=0; k<nconditions; k++)
			{
				if(!condition[k].isTrue(w,g,deltat-dt))
						continue;
				for(int i=0; i<nconditions; i++)
				{
					if(!condition[i].isTrue(w,g,deltat-dt))
						continue;
					if(k==i)
						continue;
					if(rolling)
					{
						current=hitchance[l][d][k][i].getBestRChance();
						if(current>best)// && hitchance[d][k][i].shots>+3)
						{
							best=current;
							bestgun=hitchance[l][d][k][i].getBestRRifle();
							shots=-1;//(int)hitchance[l][d][k][i].getRShots();
							c1=k;
							c2=i;
						}
					}
					current=hitchance[l][d][k][i].getBestChance();
					if(current>best)// && hitchance[d][k][i].shots>+3)
					{
						best=current;
						bestgun=hitchance[l][d][k][i].getBestRifle();
						shots=hitchance[l][d][k][i].getShots();
						c1=k;
						c2=i;
					}
				}
			}
		}
		}
		currentchance=best;
		currentgun=bestgun;
		return new Aim(bestgun,best,shots,c1,c2);
	}

	public void onPaint(java.awt.Graphics2D g)
	{
/*		g.setColor(Color.red);
		for(int i=0; i<NRIFLES; i++)
			g.drawString("Rifle"+i+":",5,i*10+20);
		for(int j=0; j<nconditions; j++)
			for(int i=0; i<NRIFLES; i++)
				g.drawString("shots="+hitchance[i][j].shots+" hits="+hitchance[i][j].hits, j*100+40, i*10+20);*/
	}	
}

class Aim
{
	double chance;
	int rifle;
	int shots=0;
	int con1=0,con2=0;
	Aim(int r, double c)
	{
		chance=c;
		rifle=r;
	}
	Aim(int r, double c,int s, int c1 , int c2)
	{
		chance=c;
		rifle=r;
		shots=s;
		con1=c1;
		con2=c2;
	}
}

class HitChance
{
	int nrifles;
	static final double A=0.7;
	static final double rollingDepth=20; 
	static final double weighting=1;
				
	private int hits[];
	private int shots;
	private double chance[];
	private double bchance;
	private int brifle;

	private double rhits[];
		
	private double rchance[];
	private double brchance;
	private int brrifle;
	
	HitChance(int NRIFLES)
	{
		nrifles = NRIFLES;
		hits = new int[NRIFLES];
		chance= new double[NRIFLES];
		rhits = new double[NRIFLES];
		rchance = new double[NRIFLES];
	}
	
	public void newHit(boolean h[])
	{
		for(int i=0;  i<nrifles; i++)
		{
			if(h[i])
				rhits[i]=rollingAvg(rhits[i],1);
			else
				rhits[i]=rollingAvg(rhits[i],0);
		}
	}
	
	private double rollingAvg(double avarage, double newEntry) {
    return (avarage * rollingDepth + newEntry * weighting)/(rollingDepth + weighting);} 
	
	public void newShot()
	{
		shots++;
	}
	
	public int getShots(){
		return shots;}
			
	void newChance()
	{
		bchance=0;
		brchance=0;
		if(shots==0)
			return;
		for(int i=0;  i<nrifles; i++)
		{
			double k=Math.log(shots + 1)*0.4;
			chance[i]=(k>=1 ? 1 : k)*(double)hits[i]/(shots/100.);
			if(chance[i]>bchance)
			{
				bchance=chance[i];
				brifle=i;
			}
			if(rhits[i]>brchance)
			{
				brchance=rhits[i];
				brrifle=i;
			}
		}
	}
		
	public double getBestChance(){
		return bchance;}
	public double getBestRChance(){
		return brchance;}
		
	public int getBestRifle(){
		return brifle;}		
	public int getBestRRifle(){
		return brrifle;}		
				
	}

interface Condition
{
	public boolean isTrue(Wave w, Gun g, long dt);
}

class ConDistance implements Condition
{
	int mindis,maxdis;	
	ConDistance(int mindis, int maxdis)
	{
		this.mindis=mindis;
		this.maxdis=maxdis;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double d=g.getDistance(e.time);
		return (d>=mindis && d<maxdis);
	}
}

class ConWDistance implements Condition
{
	int mindis,maxdis;	
	ConWDistance(int mindis, int maxdis)
	{
		this.mindis=mindis;
		this.maxdis=maxdis;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double d=g.getWallDist(e.p);
		return (d>=mindis && d<maxdis);
	}
}

class ConVelocity implements Condition
{
	int minv,maxv;	
	ConVelocity(int minv, int maxv)
	{
		this.minv=minv;
		this.maxv=maxv;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double v=e.v.Length();
		return (v>=minv/10. && v<maxv/10.);
	}
}

class ConAcceleration implements Condition
{
	int minv,maxv;	
	ConAcceleration(int minv, int maxv)
	{
		this.minv=minv;
		this.maxv=maxv;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		Stats e2 = g.getEnemyTimeStats((int)w.t-3-dt);
		if(e==null) return false;
		double a=e.v.Length()-e2.v.Length();
		return (a>=minv && a<maxv);
	}
}

class ConLateralV implements Condition
{
	int minv,maxv;	
	ConLateralV(int minv, int maxv)
	{
		this.minv=minv;
		this.maxv=maxv;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		Stats m = g.getMateTimeStats((int)w.t-dt);
		if(e==null) return false;
		double lv=(Math.sin(e.p.Subtract(m.p).getA()-e.v.getA())*e.v.Length());
//		lv=Math.abs(lv);
		return (lv>=minv && lv<maxv);
	}
}
class ConLateralAV implements Condition
{
	int minv,maxv;	
	ConLateralAV(int minv, int maxv)
	{
		this.minv=minv;
		this.maxv=maxv;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		Stats m = g.getMateTimeStats((int)w.t-dt);
		if(e==null) return false;
		double lv=Math.abs(Math.sin(e.p.Subtract(m.p).getA()-e.v.getA())*e.v.Length());
//		lv=Math.abs(lv);
		return (lv>=minv && lv<maxv);
	}
}

class ConBearing implements Condition
{
	double minv,maxv;	
	ConBearing(double minv, double maxv)
	{
		this.minv=minv;
		this.maxv=maxv;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		Stats m = g.getMateTimeStats((int)w.t-dt);
		if(e==null) return false;
		double be=Utils.normalRelativeAngle(e.v.Subtract(m.p.Subtract(e.p)).getA());
//		lv=Math.abs(lv);
		return (be>=minv && be<maxv);
	}
}

class ConPower implements Condition
{
	int min,max;	
	ConPower(int min, int max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		return (w.pow>=min && w.pow<max);
	}
}

class ConCorner implements Condition
{
	int min,max;	
	ConCorner(int min, int max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
//		Stats m = g.getMateTimeStats((int)w.t);
		double d=0;//e.p.Subtract(m.p).Length();
		d=e.p.Length();	//faksch muss mit e.p.....
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(0,600))).Length(),d);
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(800,0))).Length(),d);
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(800,600))).Length(),d);
		return (d>min && d<max);
	}
}

class ConWall implements Condition
{
	int min,max;	
	ConWall(int min, int max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double d=0;
		d=e.p.getX();//siehe oben
		d=Math.min(e.p.getY(),d);
		d=Math.min(800-e.p.getX(),d);
		d=Math.min(600-e.p.getY(),d);
		return (d>min && d<max);
	}
}

class ConDWall implements Condition
{
	int min,max;	
	ConDWall(int min, int max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		Stats e2 = g.getEnemyTimeStats((int)w.t-3-dt);
		if(e==null) return false;
		double d=0;
		double d2=0;
		double dd;
		d=e.p.getX();//siehe oben
		d=Math.min(e.p.getY(),d);
		d=Math.min(800-e.p.getX(),d);
		d=Math.min(600-e.p.getY(),d);
		
		d2=e2.p.getX();//siehe oben
		d2=Math.min(e2.p.getY(),d2);
		d2=Math.min(800-e2.p.getX(),d2);
		d2=Math.min(600-e2.p.getY(),d2);
		
		dd=d-d2;
		return (dd>min && dd<max);
	}
}

class ConLastChange implements Condition
{
	int min,max;	
	ConLastChange(int min, int max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double lc=e.time-e.lchange;
		return (lc>min && lc<max);
	}
}

class ConLastGF implements Condition
{
	double min,max;	
	ConLastGF(double min, double max)
	{
		this.min=min;
		this.max=max;
	}
	
	public boolean isTrue(Wave w, Gun g, long dt)
	{
		Stats e = g.getEnemyTimeStats((int)w.t-dt);
		if(e==null) return false;
		double lgf=e.lgf;
		return (lgf>min && lgf<max);
	}
}

									