package Krabb.krabby2;
import Krabb.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.*;
import java.awt.geom.Point2D;
import java.util.*;


public class Stats implements Serializable
{
	public Vector2D p;		//Position
	public Vector2D v;		//Velocity
	public Vector2D h; 		//Heading
	public Vector2D lv;
	public double l=0;		//life
    public long time=0; 	//Zeit des Scans
	public double lchange=0;
	public double lgf=0;
	public double llgf=0;
	
	//Enemy
	public Stats(ScannedRobotEvent e, Enemy r)
	{
//		name=e.getName();
		this.lgf=r.lastgf;
		this.llgf=r.llastgf;
		l=e.getEnergy();
		v = new Vector2D(e.getHeadingRadians(),e.getVelocity());
		h = new Vector2D(e.getHeadingRadians(),1);
		double a=e.getBearingRadians()+r.getHeadingRadians();
		double d=e.getDistance();
		p = new Vector2D(new Point2D.Double(r.getX()+Math.sin(a)*d,r.getY()+Math.cos(a)*d));
		time=r.getTime();
		if(v.Length()>0)
			lv=v;
		else
		{
			if(r.getEnemyStats(0)==null)
				lv=new Vector2D(e.getHeadingRadians(),0.1);
			else
				lv=r.getEnemyStats(0).lv;
		}
	}
	
	//Mate
	public Stats(Mate r)
	{
		this.lgf=r.lmf;
		this.llgf=r.llmf;
		l=r.getEnergy();
//		if(Math.abs(r.getVelocity())>0)
		v = new Vector2D(r.getHeadingRadians(),r.getVelocity());
		h = new Vector2D(r.getHeadingRadians(),1);
//		System.out.println("HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH"+Utils.normalRelativeAngle(r.getHeadingRadians()));
		p = new Vector2D(new Point2D.Double(r.getX(),r.getY()));
		time=r.getTime();
		if(r.getTime()<2)
			lv=new Vector2D(r.getHeadingRadians(),0.2);
		else if(v.Length()>0)
			lv=v;
		else
			lv=r.getMateStats(0).lv;
		lchange=0;
		}
	
	public void onPaint(java.awt.Graphics2D g)
	{
		int x,y,x1,y1;
		g.drawRect((int)p.getX()-16,(int)(600-p.getY()-16), 32, 32);
		x=(int)p.getX();
		y=(int)(600-p.getY());
		x1=(int)(p.getX()+Math.sin(v.getA())*100);
		y1=(int)(600-(p.getY()+Math.cos(v.getA())*100));
		g.drawLine(x, y, x1, y1);
	}
}		

class Wave
{
	public Vector2D m[] = new Vector2D[2];		//Move Positionen beim eintreten und verlassen der wave
	public Vector2D p;		//Position
	public double t;		//time
	public double pow;		//Power
	public double v; 		//Velocity
	public double d;		//distance
	public boolean hit=false;
	public boolean moved=false;
	
	//Enemy
	public Wave(AdvancedRobot r, Stats e, double pow)
	{
		m[0]=null;
		p=e.p;
		t=r.getTime()-1;
		this.pow=pow;
		v=20-3*pow;
		Vector2D mp = new Vector2D(new Point2D.Double(r.getX(),r.getY()));
		d=mp.Subtract(p).Length();
	}
	
	//Mate
	public Wave(double pow, Mate r)
	{
		p = new Vector2D(new Point2D.Double(r.getX(),r.getY()));
		t=r.getTime();
		this.pow=pow;
		v=20-3*pow;
		d=p.Subtract(r.getEnemyStats().p).Length();
	}	

	public void onPaint(java.awt.Graphics2D g,AdvancedRobot r)
	{
		g.setColor(Color.red);
		int radius=(int)(v*(r.getTime()-t));
		g.drawOval((int)(p.getX()-radius),(int)(600-p.getY()-radius),2*radius,2*radius);
	}
	
	public void onPaint2(java.awt.Graphics2D g,AdvancedRobot r)
	{
		g.setColor(Color.green);
		int radius=(int)(v*(r.getTime()-t));
		g.drawOval((int)(p.getX()-radius),(int)(600-p.getY()-radius),2*radius,2*radius);
	}
}