package Krabb.krabby2;
import Krabb.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.*;
import java.awt.geom.Point2D;
import java.util.*;

public class StatsReader extends Mate
{
	//Enemy distance
	public double getDistance(long t){
		return getEnemyTimeStats(t).p.Subtract(getMateTimeStats(t).p).Length();}
	
	//Enemy bearing
	public Vector2D getEnemyBearing(long t){
		return getEnemyTimeStats(t).p.Subtract(getMateTimeStats(t).p);}
		
	//Enemy acceleration
	public double getEnemyAcceleration(long t){
		Stats e = getEnemyTimeStats(t);
		Stats e2 = getEnemyTimeStats(t-3);
		return e.v.Length()-e2.v.Length();}
		
	//Wall distance
	private double getWallDist(Stats e){
		double d=e.p.getX();
		d=Math.min(e.p.getY(),d);
		d=Math.min(getBattleFieldWidth()-e.p.getX(),d);
		d=Math.min(getBattleFieldHeight()-e.p.getY(),d);
		return d;}
	
	//Wall dist.		
	public double getWallDist(Vector2D p){
		double d=p.getX();
		d=Math.min(p.getY(),d);
		d=Math.min(getBattleFieldWidth()-p.getX(),d);
		d=Math.min(getBattleFieldHeight()-p.getY(),d);
		return d;}
	
	//Enemy Wwall dist.
	public double getEnemyWallDist(long t){
		return getWallDist(getEnemyTimeStats(t));}
		
	//Mate (My) wall dist.
	public double getMateWallDist(long t){
		return getWallDist(getMateTimeStats(t));}
		
/*	unused	
	public double getEnemyWallAcceleration(long t){
		return 	getEnemyWallDist(t)-getEnemyWallDist(t-1);}

	public double getMateWallAcceleration(long t){
		return 	getMateWallDist(t)-getMateWallDist(t-1);}

	private double getCornerDist(Stats e){
		double d=e.p.Length();
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(0,600))).Length(),d);
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(800,0))).Length(),d);
		d=Math.min(e.p.Subtract(new Vector2D(new Point2D.Double(800,600))).Length(),d);
		return d;}
*/		
}
