package Krabb.sliNk;
import Krabb.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.*;
import java.awt.geom.Point2D;
import java.util.*;

class Enemy extends MyRobot
{
	public long lhit=0;
	public double ldmg=0;
	BulletPStats pstats;
	GunGFStats gungfstats;
	MovementGFStats movegfstats;
	Enemy()
	{
		nsavedstats=(int)(Math.sqrt(Global.bheight*Global.bheight+Global.bwidth*Global.bwidth)/11.);
		enemie=true;
		pstats = new BulletPStats(Global.bwidth,Global.bheight);
		gungfstats = new GunGFStats();
		movegfstats = new MovementGFStats();
	}
	
	public void run()
	{
		super.run();
		lhit=0;
		ldmg=0;	
	}
	
	public void onPaint(java.awt.Graphics2D g, Data r)
	{
		super.onPaint(g,r);
		pstats.onPaint(r,this,g);
		movegfstats.onPaint(r,this,g);
		if(stats==null)
			return;
		long t=r.getTime();
		int x,y,x1,y1;
		double j = 1./Math.max(1,(t-lhit)/3.);
		g.setColor(new Color((float)j,(float)j,(float)j,1.f));
		x=(int)r.getX();
		y=(int)r.getY();
		x1=(int)getStats(0).getX();
		y1=(int)getStats(0).getY();
		g.drawLine(x, y, x1, y1);		
	}
	
	protected void newStats(Stats s)
	{
/*		System.out.println(stats+" newStats(s)"+s.getName());
		if(s==null)
			System.out.println("asdjaljksfuseioh");*/
		if(stats == null || stats.getTimeStats(s.t).t!=s.t)	//Wenn noch nicht vorhanden
			movegfstats.checkHits(this,s,Global.self);
		if(stats == null)
			stats = new LStats(s);
		else
			stats=stats.newChangeStats(s);
			//wenn zu lang ????
	}
	
	public void newHit(HitPar par)
	{
		lhit=par.ht;
		double p=par.p;
		ldmg=p*4+(p>1 ? 2 * (p-1) : 0);
		pstats.newHit(par);
		gungfstats.newHit(par);
	}
}

class Mate extends MyRobot
{
	private ArrayList bullets = new ArrayList();
	public double ffdmg=0,bbffdmg=0, bbendmg=0, endmg=0,misdmg=0;
	Mate()
	{
		nsavedstats=(int)(Math.sqrt(Global.bheight*Global.bheight+Global.bwidth*Global.bwidth)/11.);
		enemie=false;
	}
	
	public void run()
	{
		super.run();
		bullets.clear();
	}
		
	public void step(AdvancedRobot r)
	{
		for(int i=0; i<bullets.size(); i++)
			if(((MyBullet)bullets.get(i)).test(r))
				bullets.remove(i--);
	}
	
	public void newBullet(MyBullet b)
	{
		bullets.add(0,b);
	}
	
	public MyBullet getOwnBullet(Bullet b)
	{
		for(int i=0; i<bullets.size(); i++)
			if(((MyOwnBullet)bullets.get(i)).b==b)
				return (MyBullet)bullets.get(i);
		return null;
	}
		
	public Collection getBullets(){
		return bullets;}

	public void bulletHit(MyBullet b)
	{
		MyBullet bu;
		for(int i=0; i<bullets.size(); i++)
			if((bu=(MyBullet)bullets.get(i)).t==b.t)
			{
				bu.hit=true;
				return;
			}
	}

	public void onBulletHitBullet(BulletHitBulletEvent e, Data r)
	{
		double p=e.getBullet().getPower();
		if(r.isTeammate(e.getHitBullet().getName()))
			bbffdmg+=p*4+Math.max(0,(p-1)*2);
		else
			bbendmg+=p*4+Math.max(0,(p-1)*2);
//		System.out.println("onBulletHitBullet(BulletHitBulletEvent e)!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11");
	}
	
	public void onBulletHit(Data r, BulletHitEvent e)
	{
		double p=e.getBullet().getPower();
		if(r.isTeammate(e.getName()))
			ffdmg+=p*4+Math.max(0,(p-1)*2);
		else
			endmg+=p*4+Math.max(0,(p-1)*2);
//		System.out.println("onBulletHit(BulletHitEvent e)");
	}
	
	public void onBulletMissed(BulletMissedEvent e)
	{
		double p=e.getBullet().getPower();
		misdmg+=p*4+Math.max(0,(p-1)*2);
//		System.out.println("onBulletMissed(BulletMissedEvent e)");	
	}
	
	public void printStats()
	{
		double dmg=ffdmg+bbffdmg+bbendmg+endmg+misdmg;
		System.out.println("FriendlyFireDamage:    "+ffdmg+" "+100.*ffdmg/dmg+"%");
		System.out.println("EnemyHitDamage:        "+endmg+" "+100.*endmg/dmg+"%");
		System.out.println("BulletHitBulletDamage: "+(bbffdmg+bbendmg)+" "+100.*(bbffdmg+bbendmg)/dmg+"%");
		System.out.println("    FrientlyBullet:    "+bbffdmg+" "+100.*bbffdmg/dmg+"%");
		System.out.println("    EnemyBullet:       "+bbendmg+" "+100.*bbendmg/dmg+"%");
		System.out.println("MissedBulletDamage:    "+misdmg+" "+100.*misdmg/dmg+"%");
	}

	public void onPaint(java.awt.Graphics2D g, Data r)
	{
		super.onPaint(g,r);
		long t=r.getTime();
		int x,y,x1,y1;
		MyBullet b;
		g.setColor(Color.green);
		for(int i=0; i<bullets.size(); i++)
		{
			b=(MyBullet)bullets.get(i);
			if(b.hit)
				continue;
			x=(int)b.getX();
			y=(int)b.getY();
			x1=(int)(b.getX()+Math.sin(b.getH())*b.getV()*(t-b.t));
			y1=(int)(b.getY()+Math.cos(b.getH())*b.getV()*(t-b.t));
			g.drawLine(x, y, x1, y1);		
		}
	}	
	
}

class MyRobot
{
	long nsavedstats=130;
//	long nstats=0;
	protected LStats stats=null;
	public boolean enemie;
	public void run()
	{
		stats=null;
//		nstats=0;
	} 
	
	protected void newStats(Stats s)
	{
/*		System.out.println(stats+" newStats(s)"+s.getName());
		if(s==null)
			System.out.println("asdjaljksfuseioh");*/
		if(stats == null)
			stats=new LStats(s);
		else
			stats=stats.newStats(s);
//		nstats++;
			//wenn zu lang ????
	}
	
	public void step(AdvancedRobot r)
	{
			
	}
		
	protected void newScan(ScannedRobotEvent e, Data r)
	{
		newStats(new Stats(e,r,getStats(0)));
	}
	
	public void death(){
		getStats(0).alive = false;}
	
	public void onPaint(java.awt.Graphics2D g, Data r)
	{
		if(stats!=null)
			stats.onPaint(g);
	}
	public LStats getLStats(){
		return stats;}
	public Stats getFirstStats(){
		if(stats==null) return null;
		return stats.getStats();}
	public Stats getStats(long n){
		if(stats==null)
			return null;
		return stats.getStats(n,0);}
	public Stats getTimeStats(long t){
		if(stats==null)
			return null;
		return stats.getTimeStats(t);}	
/*	public long getnStats(){
		return nstats;}*/
}