package SHAM;

import robocode.*;


/**
 * SHAM.WOW created by Steven Hatton and Aditya Majumdar Period 3, JAVA
 * Programming Due: 06/05/09 Robocode, JAVA, Second Semester Final Project
 * 
 * Basic, root helper class, returns specific information of the enemy robots.
 * Including, but not limited to, bearing, heading, energy, distance, etc.
 */
public class EnemyBot
{
    private double bearing, distance, energy, heading, velocity;

    private String name;


    public EnemyBot()
    {
        reset();
    }


    public double getBearing()
    {
        return bearing;
    }


    public double getDistance()
    {
        return distance;
    }


    public double getEnergy()
    {
        return energy;
    }


    public double getHeading()
    {
        return heading;
    }


    public double getVelocity()
    {
        return velocity;
    }


    public String getName()
    {
        return name;
    }


    public void update( ScannedRobotEvent srEvt )
    {
        bearing = srEvt.getBearing();
        distance = srEvt.getDistance();
        energy = srEvt.getEnergy();
        heading = srEvt.getHeading();
        velocity = srEvt.getVelocity();
        name = srEvt.getName();
    }


    public void reset()
    {
        bearing = 0.0;
        distance = 0.0;
        energy = 0.0;
        heading = 0.0;
        velocity = 0.0;
        name = "";
    }


    public boolean none()
    {
        if ( name.equals( "" ) )
        {
            return true;
        }
        return false;
    }
}