package adt;
import robocode.*;
import java.util.LinkedList;
import java.awt.geom.Point2D;

/**
 * MyClass - a class by (your name here)
 */
public class RobotMemory {
	Robot self;
	String name;
	LinkedList entries = new LinkedList();
	final int maxSize = 10;
	
	public RobotMemory( Robot self, String name )
	{
		this.self = self;
		this.name = name;
	}
	
	public void update( long t, Object eventData, Point2D.Double position )
	{
		entries.addFirst( new RobotMemoryEntry( t,eventData,position ) );
		if ( entries.size() > maxSize )
		{
			entries.removeLast();
		}
	}
	
	public Point2D.Double getAimPoint()
	{
		if ( entries.size() > 0 )
		{
			RobotMemoryEntry thisMemoryEntry = (RobotMemoryEntry)(entries.getFirst());
			return thisMemoryEntry.getPosition();
		}
		return null;
	}
	
	public double getEnergy()
	{
		if ( entries.size() > 0 )
		{
			RobotMemoryEntry thisMemoryEntry = (RobotMemoryEntry)(entries.getFirst());
			return thisMemoryEntry.getEnergy();
		}
		return 0.0;
	}
}

