package ayk;

import java.awt.geom.Rectangle2D;
import robocode.*;
import robocode.util.Utils;
/**
 * WallHugger 1.0
 * by Ali Khan (aka Khanguy)
 *  
 * nano sized wallhugging robot that uses wallsmoothing
 *  - movement - wallhugging with a VelocityTrick
 *  - gun - uses a linear gun
 *  - codesize - (using Jikes) exactly 249  - just barely a nanobot :D
 * This is melee version of SmoothHugger 1.0 
 * 
 * Released under RWPCL
 */
public class WallHugger extends AdvancedRobot{
	
	static int direction = 1;
	static double lastDistance;
	
	public void run() {
		
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);

		turnRadarRightRadians(Double.POSITIVE_INFINITY);	
	}


	public void onScannedRobot(ScannedRobotEvent e) {

		//***********************SET UP *****************************
			double v1;
		//***********************MOVEMENT************************
			setMaxVelocity(Math.random() * 12); // Velocity Trick

			//Pez's wall smoothing code with adaptation to make it hug walls clockwise
			//original wallhugging code is at http://robowiki.net/wiki/Talk:Wall_Smoothing/Implementations
			
			//I want to go either forward or backward of my current heading
			v1 = (getHeadingRadians() )+ ((direction ==1)?0:(Math.PI)); 
			while (!new Rectangle2D.Double(20, 20, 960,
			    960).contains(getX() + Math.sin(v1) * 160, getY() + Math.cos(v1) * 160)) v1 += .05*direction;	

			
			// SetBackAsFrontCode adapted from Jen(Voidious)
    			 setTurnRightRadians((Math.tan(v1  -= getHeadingRadians())));
       			setAhead(Math.cos(v1) * Double.POSITIVE_INFINITY);
				
				//setAhead(Math.cos(v1 -= getHeadingRadians()) * Double.POSITIVE_INFINITY);
				//setTurnRightRadians((Math.tan(v1)));
			
			
			
	 	//********************RADAR and GUN**********************

		// lock code (based on DustBunny)
			if((setFireBullet((700/(v1 = e.getDistance())))) != null)
		{
			lastDistance = Double.POSITIVE_INFINITY;
		}

		// Lock onto closest bots		
		if(lastDistance + 100> (v1))
		{
			lastDistance = v1;
				// Let this var be equal the the absolute bearing now...
				// and set the radar.
				setTurnRadarLeft(getRadarTurnRemaining());
				
				// This would be nice to prevent the occasional long shot.				
				//clearAllEvents();
		
		//reduced linear gun
		setTurnGunRightRadians(Utils.normalRelativeAngle((v1 = e.getBearingRadians() + getHeadingRadians())- 
    		getGunHeadingRadians() + (e.getVelocity() * Math.sin(e.getHeadingRadians() - 
			v1) / (11))));
		}
	}	
	
	public void onHitRobot(HitRobotEvent e){ 
		//turnRadarRightRadians((e.getBearingRadians() + getHeadingRadians() )- getRadarHeading());
		direction = -direction;
	}

	


}
