package bugger;
import robocode.*;
import java.awt.geom.Point2D;
import robocode.util.Utils;

/**
 * Worker - a robot by (your name here)
 */
public class Worker extends TeamRobot implements Droid
{
	double FORWARD = 1;//choose forward or backward
	double rand = 185;//a random number that changes
	/**
	 * run: Droid's default behavior
	 */
	public void run() {
		setAdjustGunForRobotTurn(true);
		System.out.println("MyFirstDroid ready.");
	}
	
	/**
	 * onMessageReceived: What to do when our leader sends a message
	 */
	public void onMessageReceived(MessageEvent e)
	{
		//here I use an oscillating movement pattern, but
//I use a constant "rand" that I change randomly
//so that Patternmatchers can't lock onto me
if (getDistanceRemaining() == 0) { FORWARD =
	-FORWARD; setAhead(rand * FORWARD);}
setTurnRightRadians(0
+Math.PI/2-0.5236*FORWARD
*(0>200?1:-1));
		// Fire at a point
		if (e.getMessage() instanceof Point)
		{
			Point p = (Point)e.getMessage();
			// Calculate x and y to target
			double dx = p.getX() - this.getX();
			double dy = p.getY() - this.getY();
			// Calculate angle to target
			double theta = Math.toDegrees(Math.atan2(dx,dy));
			// Turn gun to target
			turnGunRight(normalRelativeAngle(theta - getGunHeading()));
			// Fire hard!
			fire(3);
		}
		// Set our colors
		else if (e.getMessage() instanceof RobotColors)
		{
			RobotColors c = (RobotColors)e.getMessage();
			setColors(c.getBodyColor(),c.getGunColor(),c.getRadarColor());
		}
	}
	
	/**
	 * normalRelativeAngle:  returns angle such that -180<angle<=180
	 */	
	public double normalRelativeAngle(double angle) {
		if (angle > -180 && angle <= 180)
			return angle;
		double fixedAngle = angle;
		while (fixedAngle <= -180)
			fixedAngle += 360;
		while (fixedAngle > 180)
			fixedAngle -= 360;
		return fixedAngle;
	}
}
