package cs;

import robocode.*;
import robocode.util.Utils;
//import java.awt.Color;

public final class ExclusionNano extends AdvancedRobot {
	private static int direction;
	private static double lastEnergy, vel;
	
	public final void run() {
		//setAdjustGunForRobotTurn(true);
		//setAdjustRadarForGunTurn(true);
		//setAllColors(Color.WHITE);
		lastEnergy = 100;
		direction = 1;
		vel = 0;
		while(true)
			turnRadarRightRadians(1/0.0);
	}
	public final void onScannedRobot(ScannedRobotEvent e) {
		double d0, d1, d2;
		
		//infinity lock
	    setTurnRadarLeftRadians(getRadarTurnRemainingRadians());
	    
	    setFire(d1=Math.min(3,1300/(d2 = e.getDistance()) - 2));

		if((d0 = e.getEnergy()) < lastEnergy || d2 < 200)
			setAhead(direction*(40+Math.random()*60));
		lastEnergy = d0;
		
		d2 = 1.57 + ((d2/300-1) * -direction);
	    
	    setTurnRightRadians(Utils.normalRelativeAngle((d0=e.getBearingRadians()) + d2));
	    d0 += getHeadingRadians();
	    
	    setTurnGunRightRadians(Utils.normalRelativeAngle(d0 - 
		        getGunHeadingRadians() + (
		        	((vel += Math.abs(e.getVelocity()))/e.getTime()) * Math.signum(e.getVelocity())
		        * Math.sin(e.getHeadingRadians() - 
		        d0) / Rules.getBulletSpeed(d1))));
	}
	
	public void onHitByBullet(HitByBulletEvent e) {
		if(Math.random() < 0.5)
			direction = -direction;
	}
	
	public void onBulletHit(BulletHitEvent e) {
		lastEnergy = getEnergy();
	}
	
	public void onHitWall(HitWallEvent event) {
		direction = -direction;
	}
}
