package eld;
import robocode.*;
import java.math.*;
import java.io.*;
import java.awt.Color;

/**
 * Hmm - a robot by (your name here)
 */
public class Hmm extends AdvancedRobot
{

	public void run() {
		setColors(Color.red,null,null);
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		while(true) {
			setTurnRadarRightRadians(Double.POSITIVE_INFINITY);
			execute();
		}
	}
	
	public void onScannedRobot(ScannedRobotEvent e) {
		double 
			Mhead = getHeadingRadians(),
			bearing = e.getBearingRadians()+Mhead,
			Evel = e.getVelocity(),
			Ehead = e.getHeadingRadians(),
			EtanV = Evel*Math.sin(Ehead-bearing),
			EheadV = Evel*Math.cos(Ehead-bearing),
			Mvel = getVelocity(),
			MtanV = -Mvel*Math.sin(Mhead-bearing),
			MheadV = -Mvel*Math.cos(Mhead-bearing),
			Xdist = Math.min(getX(), getBattleFieldWidth()-getX()),
			Ydist = Math.min(getY(), getBattleFieldHeight()-getY()),
			//Mxvel = Mvel*Math.sin(Mhead),
			//Myvel = Mvel*Math.cos(Mhead),
			//Wdist = Math.min(Math.min(getX(), getBattleFieldWidth()-getX()),Math.min(getY(), getBattleFieldHeight()-getY())),
			//Wdprime = Math.min(Xdist,Ydist/(
			//arena = Math.min(getBattleFieldWidth(), getBattleFieldHeight()),
			Edist = e.getDistance(),
			Bpower = MR(3)*getEnergy()/(Edist+1)+7500/(Edist*Edist+1),
			Bspeed = 20-3*Bpower,
			dprime = Edist+EheadV+MheadV,
			dGtime = Math.abs(dprime/(Bspeed-EheadV)),
			GEturn = PN((int)dGtime)*(Math.PI/18-Math.PI/240*Evel),
			GEvel = Evel+MR(1)*PN((int)dGtime),
			//GEtanV = GEvel*Math.sin(Ehead-bearing) ,
			GEtanV = GEvel*Math.sin(Ehead+GEturn-bearing) ,
			//GEheadV = GEvel*Math.cos(Ehead-bearing) ,
			GEheadV = GEvel*Math.cos(Ehead+GEturn-bearing) ,
			Gtime = -dprime/(GEheadV-Bspeed);
			//while(dprime+(EheadV-Bspeed)*Gtime > .0001){ Gtime += ((EheadV)*Gtime)/Bspeed;}
			setTurnRightRadians(normalizeBearing(bearing-Mhead+Math.PI/2+1000*(-Mvel/(Math.abs(Mvel)+.1)*(1/(Xdist*Xdist+1)+1/(Ydist*Ydist+1))/*-1/(Edist*Edist+1)*/)));
			setTurnGunRightRadians(normalizeBearing(Math.atan2((GEtanV*Gtime),(dprime+GEheadV*Gtime))+Math.atan2((EtanV+MtanV),(dprime))-getGunTurnRemainingRadians()-getGunHeadingRadians()+bearing));
			if (getGunHeat() == 0 ){ setFire(Bpower);}	
			out.println(getVelocity());
			out.println(getDistanceRemaining());
			//setAhead((Math.random()*2-1)*(16*(1+4/(1+Mvel))+e.getEnergy()%Math.PI/Math.PI*getDistanceRemaining()));
			setAhead((Mvel/2+2/(Mvel*Mvel+1)+10000*(1/(Xdist*Xdist+1)+1/(Ydist*Ydist+1)))*(MR(7)*MR(7)*PN(2))+/*e.getEnergy()%(Math.PI*(1+getRoundNum()%3))*/((MR(7)+PN(14))*(MR(7)+PN(14)))/((Math.abs(Mvel)+.1))*getDistanceRemaining());
			//setAhead(PN*e.getEnergy()%3.1/3.1*Math.random()*Math.random()*1000+(.5+.5*Math.random()+Math.random()*(2500/(Edist*Edist))+Math.random()*1/(1+(MtanV)*(MtanV))+Math.random()*(1600/(Wdist*Wdist)))*getDistanceRemaining());
			//setAhead(PN*(1.21)*(e.getEnergy()%(Math.PI)/Math.PI)*Math.random()*Math.random()*(1000)+getDistanceRemaining()*((.4+.1*(getTime())%5000/5000)+((.5+(getTime()+5000)%10000/10000)*(getTime()%4)/2*17/(1+(MtanV+1)*(MtanV+1)))+Math.random()*(2500/(Edist*Edist))+Math.random()*(1600/(Wdist*Wdist))));
			//setAhead(PN*(Wdist-50)/(Math.abs(Wdist-50))*(getEnergy()%(5*Math.E)*4+e.getEnergy()%(Math.PI)*20)+getDistanceRemaining());
			setTurnRadarRightRadians(-getRadarTurnRemainingRadians());
			execute();
	}
	
	static double normalizeBearing(double angle) {
        return Math.atan2(Math.sin(angle), Math.cos(angle));
    }

	double PN(int terms){
		double store = 0;
		int i = 0;
		while (i < terms) {store += (Math.random()*2-1); i++;}
		return store;
	}
	
	double PNT(double amount, int power){
		double store = 0;
		int i = 0;
		while (i <= power) { store *= amount*PN(power); i++;}
		return store;
	}
	double MR(int terms){
		double store = 0;
		int i = 0;
		while (i < terms) { store += Math.random(); i++;}
		return store;
	}
		
	double MRT(double amount, int power){
		double store = 0;
		int i = 0;
		while (i <= power) { store *= amount*MR(power); i++;}
		return store;
	}
	
	double SPNT(double amount, int power){
		double store = 0;
		int i = 0;
		while (i <= power) { store += PNT(amount,power);i++;}
		return store;
	}
	

	double SMRT(double amount, int power){
		double store = 0;
		int i = 0;
		while (i <= power) { store += MRT(amount,power);i++;}
		return store;
	}
	

}
