package jk.mega;

import robocode.*;
import java.util.*;
import java.io.*;
import java.awt.Color;
import jk.mega.dGun.*;
import jk.mega.dMove.*;
import jk.melee.*;
import jk.precise.*;
public class DrussGT extends AdvancedRobot{

   public DrussMoveGT move;
   public MeleeRadar radar;
   public DrussGunDC gun;
   public EnergyDomeWorker shield;

   public static final double SHIELD_THRESHOLD = 99;
   static boolean shieldEnabled = true;
   
   static{
      FastTrig.init();
   }

   public void run(){
   
      setAdjustRadarForGunTurn(true);
      setAdjustRadarForRobotTurn(true);
      setAdjustGunForRobotTurn(true);
      setColors( new Color(40, 40, 0), new Color(0, 40, 0),  Color.GRAY);
      
      setTurnRightRadians(Double.POSITIVE_INFINITY);
      setTurnGunRightRadians(Double.POSITIVE_INFINITY);
      setTurnRadarRightRadians(Double.POSITIVE_INFINITY);
      
      try{
         move = new DrussMoveGT(this);
      }
      catch(Exception ex){contain(ex);}
      try{
         radar = new MeleeRadar(this);
      }
      catch(Exception ex){contain(ex);}
      try{
         gun = new DrussGunDC(this);
      }
      catch(Exception ex){contain(ex);}
      
      if(shieldEnabled)
         try{shield = new EnergyDomeWorker(this);}
         catch(Exception ex){contain(ex);}
   
      while(true){
         try{
            move.onTick();
         }
         catch(Exception ex){contain(ex);}
         try{
            radar.onTick();
         }
         catch(Exception ex){contain(ex);}
         try{
         }
         catch(Exception ex){contain(ex);}
         execute();
      }
   }

   public void onScannedRobot(ScannedRobotEvent e){
      if(shieldEnabled){
         shieldEnabled = shield.aboveScore(SHIELD_THRESHOLD);
         if(shieldEnabled){
            try{
               shield.onScannedRobot(e);
               shield.applyActions();
            }
            catch(Exception ex){contain(ex);}
         }
      }
   
      DataToGun dtg = new DataToGun();
      try{
         move.onScannedRobot(e);
         if(!shieldEnabled)
            move.doSurfing();
         dtg = move.getGunInfo();
      }
      catch(Exception ex){contain(ex);}
      
      try{radar.onScannedRobot(e);}
      catch(Exception ex){contain(ex);}
      
      
      if(!shieldEnabled){
         Bullet b = null;
         try{b = gun.onScannedRobot(e, dtg.futurePoint,dtg.futureHeading,dtg.futureVelocity,dtg.timeInFuture,dtg.enemyBP);}
         catch(Exception ex){contain(ex);}
      
         try{move.logMyBullet(b);}
         catch(Exception ex){contain(ex);}
      }
   }
   public void onRobotDeath(RobotDeathEvent e){
      try{move.onRobotDeath(e);}
      catch(Exception ex){contain(ex);}
      
      try{radar.onRobotDeath(e);}
      catch(Exception ex){contain(ex);}
      
      // try{
         // gun.onRobotDeath(e);
      // }
      // catch(Exception ex){contain(ex);}
      
   }
   public void onHitByBullet(HitByBulletEvent e){
      try{move.onHitByBullet(e);}
      catch(Exception ex){contain(ex);}
      
      if(shieldEnabled)
         try{shield.onHitByBullet(e);}
         catch(Exception ex){contain(ex);}
   }      
   public void onHitRobot(HitRobotEvent e){
      try{move.onHitRobot(e);}
      catch(Exception ex){contain(ex);}
   }
   public void onBulletHitBullet(BulletHitBulletEvent e){
      try{move.onBulletHitBullet(e);}
      catch(Exception ex){contain(ex);}
      
      
      if(!shieldEnabled)
         try{gun.onBulletHitBullet(e);}
         catch(Exception ex){contain(ex);}
      
      if(shieldEnabled)
         try{  shield.onBulletHitBullet(e);}
         catch(Exception ex){contain(ex);}
   }
   public void onBulletHit(BulletHitEvent e){
      try{ move.onBulletHit(e);}
      catch(Exception ex){contain(ex);}
      
      if(!shieldEnabled)
         try{gun.onBulletHit(e);}
         catch(Exception ex){contain(ex);}
   
      if(shieldEnabled)
         try{  shield.onBulletHit(e);}
         catch(Exception ex){contain(ex);}
   }
   public void onPaint(java.awt.Graphics2D g){
      move.onPaint(g);
      if(!shieldEnabled)
         gun.onPaint(g);
   }
   public void onDeath(DeathEvent e){
      shieldEnabled = false;
      try{ 
      // gun.onDeath(e);
         move.onDeath(e);
         // gun.onEndOfBattle();
         // finishes[getOthers()]++;
         // System.out.println("Finishes: " + Arrays.toString(finishes));
      }
      catch(Exception ex){contain(ex);}
   }
   public void onWin(WinEvent e){
      try{
         move.onWin(e);
         // finishes[0]++;
         // gun.onEndOfBattle();
         // System.out.println("Finishes: " + Arrays.toString(finishes));
      }
      catch(Exception ex){contain(ex);}
   }

   public void contain(Exception e){
   
      e.printStackTrace();
         
      try{
         PrintStream out = new PrintStream(new RobocodeFileOutputStream(getDataFile((int)(Math.random()*1000) + ".error")));
         e.printStackTrace(out);
         out.flush();
         out.close();
      }
      catch (IOException ioex){}
   }


}