   package jk.melee;

   import java.util.*;
   import java.awt.geom.*;
   import java.awt.Color;

   import ags.utils.*;
   import jk.mega.FastTrig;
   
   import robocode.*;
   import robocode.util.*;
   

   public class MeleeGun {
    
      static Hashtable<String,EnemyInfo> enemies = new Hashtable<String,EnemyInfo>();
      AdvancedRobot bot;
      Point2D.Double myLocation;
      double MAX_X, MAX_Y;
      boolean painting = false;
      
      ArrayList<Point2D.Double> targetPoints = new ArrayList<Point2D.Double>();
      ArrayList<Point2D.Double> observePoints = new ArrayList<Point2D.Double>();
      
      ArrayList<DelayWave> delayWaves = new ArrayList<DelayWave>();
   	
   	
      public MeleeGun(AdvancedRobot _bot){
         bot = _bot;
      
         MAX_X = bot.getBattleFieldWidth();
         MAX_Y = bot.getBattleFieldHeight();
         
         Enumeration<EnemyInfo> e = enemies.elements();
         while(e.hasMoreElements()){
            EnemyInfo eInfo = e.nextElement();
            
            eInfo.alive = true;
            eInfo.lastScan = null;
         }
      }
      public void onTick(){         
         myLocation =  new Point2D.Double(bot.getX(), bot.getY());   
         Point2D.Double myNextLocation = project(myLocation,bot.getHeadingRadians(),bot.getVelocity());
         
         {
            int time = (int)bot.getTime();
            for(int i = 0; i < delayWaves.size(); i++){
               DelayWave dw = delayWaves.get(i);
               EnemyInfo ei = enemies.get(dw.payload.name);
               
               double bulletDist  = (time - dw.fireTime)*dw.velocity;
               
               boolean add = !ei.alive && bulletDist > 200;
               if(!add && ei.lastScan != null){
                  double dist = ei.lastScan.location.distance(dw.fireLocation);
                  add = bulletDist > dist;
               }
            
               if(add){
                  ei.infoTree.addPoint(dw.payload.treeLocation(),dw.payload);
                  delayWaves.remove(i);
                  i--;
               }
            
            }
         
         }
         double bulletPower = Math.min(2.95,bot.getEnergy()/10);
         
         double minDist = Double.POSITIVE_INFINITY;
         {//adapt bullet power for bots in GF +-1
            double maxEnergy = 0;
            double maxEscapeAngle = maxEscapeAngle(20 - 3*bulletPower);
            double gunHeading = bot.getGunHeadingRadians();
            Enumeration<EnemyInfo> en = enemies.elements();
            while(en.hasMoreElements()){
               EnemyInfo ei = en.nextElement();
               if(!ei.alive || ei.lastScan == null)
                  continue;
            
               double gunOffset = Math.abs(
                  Utils.normalRelativeAngle(
                  gunHeading - absoluteAngle(myNextLocation,ei.lastScan.location)));
            
               if(gunOffset < maxEscapeAngle){
                  maxEnergy = Math.max(ei.lastScan.energy,maxEnergy);
                  minDist = Math.min(minDist,ei.lastScan.location.distance(myNextLocation));
               }
            }
            bulletPower = Math.min(bulletPower, maxEnergy/4);
            bulletPower = Math.min(bulletPower,40/Math.sqrt(minDist));
            // if(Math.abs(2.5 - bulletPower) < 0.25) bulletPower = 2.45;
            if(Math.abs(2 - bulletPower) < 0.25) bulletPower = 1.95;
            if(Math.abs(1.5 - bulletPower) < 0.25) bulletPower = 1.45;
            if(Math.abs(1 - bulletPower) < 0.25) bulletPower = 0.95;
            // if(Math.abs(0.5 - bulletPower) < 0.25) bulletPower = 0.45;
         }
         double bulletVelocity = 20 - 3*bulletPower;
         
      	
         //if(bot.getGunTurnRemainingRadians() == 0.0)
         {
            targetPoints.clear();
            double[] aimScores = new double[2024];
            // ArrayList<Indice> indices = new ArrayList<Indice>(100);
            long time = bot.getTime();
            Enumeration<EnemyInfo> en = enemies.elements();
            while(en.hasMoreElements()){
               EnemyInfo testE = en.nextElement();
               if(testE.alive && testE.lastScan != null){
                  EnemyScan s = testE.lastScan;
                  long timeAdvance = time - s.time;
                  if(s.nearest == null){
                     s.nearest = testE.infoTree.nearestNeighbor(
                        s.treeLocation(),
                        (int)limit(0,400/(bot.getOthers()+1),Math.min(100,Math.sqrt(testE.infoTree.size()))),
                        true
                        );
                  }
                  double[] botAimScores = new double[aimScores.length];
                  double botWeight = 0;
               
                  double startDist = myNextLocation.distance(s.location);
                  double startAngle = absoluteAngle(s.location,myNextLocation);
               	
               	                 
                  double gunTurnDelay = Math.max(Math.ceil(Math.abs(Utils.normalRelativeAngle
                     (Math.PI + startAngle - bot.getGunHeadingRadians())/Rules.GUN_TURN_RATE_RADIANS)),
                     Math.ceil(bot.getGunHeat()/bot.getGunCoolingRate()))+1;
               	
                  Iterator<KdTree.Entry<EnemyScan>> it = s.nearest.iterator();
                  int pifHits = s.nearest.size();
                  while(it.hasNext() && pifHits > 0){
                     KdTree.Entry<EnemyScan> v = it.next();
                  
                     EnemyScan replayStart = v.value;
                     double velocityFlip = Math.signum(s.velocity) == Math.signum(replayStart.velocity)?1:-1;
                     double headingDiff = replayStart.heading - s.heading;
                  	
                     Point2D.Double observeLocation = project(
                        replayStart.location,
                        startAngle + headingDiff - Math.PI/2 + Math.PI/2*velocityFlip,
                        startDist);
                     
                     double replayStartTime = replayStart.time + timeAdvance + gunTurnDelay - 2;
                     //System.out.println(" time advance: " + timeAdvance + "  gunTurnDelay: " + gunTurnDelay);
                     double radius = 0;//-timeAdvance*bulletPower;
                     EnemyScan replay = replayStart;
                     boolean broken = false;
                     ArrayList<Point2D.Double> tempTargetPoints = new ArrayList<Point2D.Double>();
                     int ticker = 150;
                     while(observeLocation.distance(replay.location) > (radius) && ticker-- > 0){
                        replay = replay.next;
                        if(replay == null){
                           broken = true;
                           break;	
                        }
                        radius = (replay.time - replayStartTime)*bulletVelocity;
                     }
                     if(broken)
                        continue;
                        
                     if(ticker == 0){
                        System.out.println("overrun on gun PIF");
                        continue;
                     }
                        
                     EnemyScan replayBefore = replay.previous;
                     long dt = replay.time - replayBefore.time;
                     Point2D.Double simEndLocation;
                     if(dt > 1){
                        double dx = (replay.location.x - replayBefore.location.x)/dt;
                        double dy = (replay.location.y - replayBefore.location.y)/dt;
                        double x = replayBefore.location.x,y = replayBefore.location.y;
                        double fineTime = replayBefore.time;
                     
                        radius = (fineTime - replayStartTime)*bulletVelocity;
                        ticker = 100;
                        while(Math.sqrt(sqr(x - observeLocation.x) + sqr(y - observeLocation.y)) > (radius)&& ticker-- > 0){
                           x += dx;
                           y += dy;
                           fineTime++;
                           radius += bulletVelocity;
                        }
                        if(ticker == 0){
                           System.out.println("overrun on gun interpolation");
                           System.out.println("dx: " + dx + "   dy: " + dy + "   dt: " + dt);
                           continue;   
                        }
                        simEndLocation = new Point2D.Double(x,y);
                     }
                     else
                        simEndLocation = replay.location;
                     
                     double simEndFireBearing = absoluteAngle(observeLocation,simEndLocation);
                     double endDist = observeLocation.distance(simEndLocation);
                  	
                     double endFireBearing = Utils.normalAbsoluteAngle(simEndFireBearing - headingDiff - Math.PI/2 + Math.PI/2*velocityFlip);
                     Point2D.Double endLocation = project(myNextLocation,endFireBearing,endDist);
                     
                     if(endLocation.x < 18 || endLocation.x > MAX_X - 18 || endLocation.y < 18 || endLocation.y > MAX_Y - 18)
                        continue;
                        
                     if(painting)
                        targetPoints.add(endLocation);
                        // targetPoints.add(s.location);
                   
                     //System.out.println("Target: x: " + endLocation.x + "  y: " + endLocation.y);
                     double hitWidth = 36/endDist;
                     double hitWeight = 1/(startDist*v.distance);
                     
                     // double halfWidth = hitWidth*0.5;
                     // Indice left = new Indice();
                     // left.position = Utils.normalAbsoluteAngle(endFireBearing-halfWidth);
                     // left.height = hitWeight;
                  // 	
                     // Indice right = new Indice();
                     // right.position = Utils.normalAbsoluteAngle(endFireBearing+halfWidth);
                     // right.height = hitWeight;
                  //    
                     // indices.add(left);
                     // indices.add(right);
                     botWeight += 1/v.distance;
                  	
                     logHit(botAimScores,endFireBearing,hitWidth,hitWeight);
                     pifHits--;
                     //aimScores[(int)(endFireBearing*(1/(2*Math.PI))*aimScores.length)%aimScores.length] += 1/(startDist*v.distance);
                  }
                  if(botWeight > 0){
                     botWeight = 1/botWeight;
                     for(int i = 0; i < aimScores.length; i++)
                        aimScores[i] += botWeight*botAimScores[i];
                  }
               }
            }
          
            // if(indices.size() > 0){
               // Collections.sort(indices);
            // 
               // double maxValue = Double.NEGATIVE_INFINITY, sumValue = 0;
               // int maxIndex = 0;
            // 
               // for(int i = 0; i < indices.size(); i++){
                  // Indice ind = indices.get(i);
                  // sumValue += ind.height;
                  // if(sumValue > maxValue){
                     // maxValue = sumValue;
                     // maxIndex = i;
                  // }
               // }
               // double fireBearing;
               // if(maxIndex > 0 && maxIndex < indices.size() - 1)
                  // fireBearing = (indices.get(maxIndex).position + indices.get(maxIndex + 1).position)*0.5;
               // else{
                  // fireBearing = Utils.normalAbsoluteAngle(
                     // indices.get(indices.size()-1).position + 0.5*Utils.normalRelativeAngle(
                     // indices.get(0).position - indices.get(indices.size()-1).position ));
               // 
               // }
               // bot.setTurnGunRightRadians(Utils.normalRelativeAngle(fireBearing - bot.getGunHeadingRadians()));
               // if(Math.abs(bot.getGunTurnRemainingRadians())< 40/600.0 && bulletPower < bot.getEnergy() - 1)
                  // bot.setFire(bulletPower);
            // }
            int maxIndex = (int)limit(0,(bot.getGunHeadingRadians()*aimScores.length*(1/(2*Math.PI))),aimScores.length-1);
            // int maxFarIndex = maxIndex;
            for(int i = 0; i < aimScores.length; i++){
               if(aimScores[i] > aimScores[maxIndex])
                  maxIndex = i;
            //    // if(aimScores[i] >= aimScores[maxFarIndex])
            //       // maxFarIndex = i;     
            }
            
            int lastIndex = maxIndex;
            int counter = aimScores.length;
            while(aimScores[lastIndex] >= aimScores[maxIndex] && counter-- > 0)
               lastIndex = (lastIndex+1)%aimScores.length;
            lastIndex = (lastIndex + aimScores.length - 1)%aimScores.length;
            // int midIndex;
            // if(maxIndex < maxFarIndex)
               // midIndex = (maxIndex + maxFarIndex)/2;
            // else
               // midIndex = ((maxIndex + maxFarIndex + aimScores.length)/2)%aimScores.length;
            double maxAngle=  (maxIndex ) * (2*Math.PI) / aimScores.length;
            double lastAngle= (lastIndex ) * (2*Math.PI) / aimScores.length;
            double fireAngle = maxAngle + 0.5*Utils.normalRelativeAngle(lastAngle - maxAngle);
         			
            
            if(aimScores[maxIndex] > 0 ){
               double gunHeading =  bot.getGunHeadingRadians();
               int gunIndex = (int)Math.round(gunHeading/(2*Math.PI)*(aimScores.length))%aimScores.length;
              
               if( (aimScores[gunIndex] > 0.8*aimScores[maxIndex]
               || (bot.getGunTurnRemaining() == 0 && aimScores[gunIndex] > 0))
                && bulletPower < bot.getEnergy() - 1 && bot.getGunHeat() == 0)
                  bot.setFire(bulletPower);
               
               bot.setTurnGunRightRadians(Utils.normalRelativeAngle(fireAngle - bot.getGunHeadingRadians()));
            	
            }
         }
      }
   
      public void onScannedRobot(ScannedRobotEvent e){   
         myLocation =  new Point2D.Double(bot.getX(), bot.getY());   
         String eName = e.getName();
                            
         EnemyInfo eInfo;
         if((eInfo = enemies.get(eName)) == null){
            enemies.put(eName,eInfo = new EnemyInfo());
            eInfo.name = eName;
         }
         eInfo.alive = true;
      		
         EnemyScan et = new EnemyScan();
         if(eInfo.lastScan != null){
            eInfo.lastScan.next = et;
            et.previous = eInfo.lastScan;
         }
         eInfo.lastScan = et;
         
         et.time = bot.getTime();
         et.location = project(myLocation, bot.getHeadingRadians() + e.getBearingRadians(), e.getDistance());
         et.heading = e.getHeadingRadians();
         et.velocity = e.getVelocity();
         et.energy = e.getEnergy();
         et.enemiesAlive = bot.getOthers();
         
         long tenAgo = Math.max(0,et.time - 10);
         EnemyScan beforeTenAgo = et.previous, afterTenAgo = et;
         while(beforeTenAgo != null && beforeTenAgo.time > tenAgo){
            afterTenAgo = beforeTenAgo;
            beforeTenAgo = beforeTenAgo.previous;
         }
         if(beforeTenAgo == null)
            et.distLast10 = et.location.distance(afterTenAgo.location);
         else{
            long beforeDiff = tenAgo - beforeTenAgo.time, afterDiff = afterTenAgo.time - tenAgo;
            long gap = beforeDiff + afterDiff;
            double br = beforeDiff/(double)(beforeDiff + afterDiff),ar = 1-br;
            Point2D.Double midPoint = new Point2D.Double(
               beforeTenAgo.location.x*br + afterTenAgo.location.x*ar,
               beforeTenAgo.location.y*br + afterTenAgo.location.y*ar);
            et.distLast10 = et.location.distance(midPoint);
         }
         Point2D.Double[] corners = new Point2D.Double[]{
               new Point2D.Double(0,0),
               new Point2D.Double(0,MAX_Y),
               new Point2D.Double(MAX_X,0),
               new Point2D.Double(MAX_X,MAX_Y)
               };
         et.distToWall = Math.min(Math.min(et.location.x,MAX_X - et.location.x),
            Math.min(et.location.y,MAX_Y - et.location.y));
            
         et.distToCorner = Double.POSITIVE_INFINITY;
         for(int i = 0; i < 4; i++)
            et.distToCorner = Math.min(et.location.distanceSq(corners[i]),et.distToCorner);
         et.distToCorner = Math.sqrt(et.distToCorner);
      	
         EnemyInfo nearest = new EnemyInfo();
         nearest.lastScan = new EnemyScan();
         nearest.lastScan.location = myLocation;
         nearest.lastScan.energy = bot.getEnergy();
         double nearestDist = myLocation.distance(et.location);
         Enumeration<EnemyInfo> en = enemies.elements();
         while(en.hasMoreElements()){
            EnemyInfo testE = en.nextElement();
            if(testE.alive && testE.lastScan != null && testE != eInfo){
               double distance = et.location.distance(testE.lastScan.location);
               if(distance < nearestDist){
                  nearestDist = distance;
                  nearest = testE;
               }
            }
         }
         et.distToNearest = nearestDist;
         double bearingFromNearest = absoluteAngle(nearest.lastScan.location,et.location);
         et.latVelToNearest = et.velocity*FastTrig.sin(et.heading - bearingFromNearest);
         et.advVelToNearest = et.velocity*FastTrig.cos(et.heading - bearingFromNearest);
         
         et.nearestEnergyRatio = et.energy/nearest.lastScan.energy;
         et.nearestEnemyEnergy = nearest.lastScan.energy;	
         
         et.name = eName;
      	
         DelayWave dw = new DelayWave();
         dw.velocity = 14;
         dw.fireLocation = myLocation;
         dw.fireTime = (int)bot.getTime();
         dw.payload = et;
         delayWaves.add(dw);
         //eInfo.infoTree.addPoint(et.treeLocation(),et);
         
      }
    
      static  Point2D.Double project(Point2D.Double location, double angle, double distance){
         return new Point2D.Double(location.x + distance*FastTrig.sin(angle), location.y + distance*FastTrig.cos(angle));
      }
      static double absoluteAngle(Point2D source, Point2D target) {
         return FastTrig.atan2(target.getX() - source.getX(), target.getY() - source.getY());
      }
      public void onDeath(DeathEvent e){
         endRound();
      }
      public void onWin(WinEvent e){
         endRound();
      
      }
      void endRound(){
      
         int time = (int)bot.getTime();
         for(int i = 0; i < delayWaves.size(); i++){
            DelayWave dw = delayWaves.get(i);
            EnemyInfo ei = enemies.get(dw.payload.name);
            if(ei == null)
               continue;
         		
            double bulletDist  = (time - dw.fireTime)*dw.velocity;
               
            boolean add = !ei.alive && bulletDist > 200;
            if(!add){
               add = bulletDist > 200;
            }
            
            if(add){
               ei.infoTree.addPoint(dw.payload.treeLocation(),dw.payload);
               delayWaves.remove(i);
               i--;
            }
            
         }
         delayWaves.clear();
      
      }
       
      public void onRobotDeath(RobotDeathEvent e){
         EnemyInfo ei = enemies.get(e.getName());
         if(ei != null)
            ei.alive = false;
      }
      
      public void onPaint(java.awt.Graphics2D g){
         painting = true;
         
         g.setColor(Color.red);
         //System.out.println("targets: " + targetPoints.size());
         for(Point2D.Double p : targetPoints)
            g.drawRect((int)p.x-18,(int)p.y-18,36,36);
         
         
         g.setColor(Color.white);
         
         for(Point2D.Double p : observePoints)
            g.drawRect((int)p.x-18,(int)p.y-18,36,36);
         
         
         g.drawRect((int)myLocation.x - 18, (int)myLocation.y - 18, 36, 36);
      }
      
      static void logHit(double[] aimScores,double endFireBearing,double hitWidth,double hitWeight){
         double halfWidth = hitWidth*0.5;
         double lowAngle = Utils.normalAbsoluteAngle(endFireBearing - halfWidth),
            highAngle = Utils.normalAbsoluteAngle(endFireBearing + halfWidth);
         int lowIndex = ((int)Math.round(lowAngle*aimScores.length*(1.0/(2*Math.PI))))%aimScores.length;
         int highIndex = ((int)Math.round(highAngle*aimScores.length*(1.0/(2*Math.PI))))%aimScores.length;
         if(lowAngle < highAngle)
            for(int i = lowIndex; i <= highIndex; i++)
               aimScores[i] += hitWeight;
         else{
            for(int i = lowIndex; i < aimScores.length; i++)
               aimScores[i] += hitWeight;
            for(int i = 0; i <= highIndex; i++)
               aimScores[i] += hitWeight;
         }
         	
         
      
       
       
       
      }
      public static double limit(double min, double value, double max) {
         if(value > max)
            return max;
         if(value < min)
            return min;
         
         return value;
      }
      public static double sqr(double d){
         return d*d;}
      public static double maxEscapeAngle(double velocity) {
         return FastTrig.asin(8.0/velocity);
      }
       
      class Indice implements Comparable{
         double position,  height;
         public int compareTo(Object o){
            return (int)Math.signum(position - ((Indice)o).position);
         }
      }
      class DelayWave{
         int fireTime;
         Point2D.Double fireLocation;
         double velocity;
         
         EnemyScan payload;
      
      }
      class EnemyInfo{
         boolean alive = true;
         String name;
         
         EnemyScan lastScan;
         KdTree<EnemyScan> infoTree = new KdTree.Manhattan<EnemyScan>(8,new Integer(100000));
      
      }
      class EnemyScan {
         String name;
         EnemyScan previous;
         EnemyScan next;
      
         List<KdTree.Entry<EnemyScan>> nearest;
       
         long time;
         Point2D.Double location;
         double heading;
         double velocity;
         double energy;  
         
      	
         double nearestEnemyEnergy;
         
         double distLast10;
         double distToWall;
         double distToCorner;
         double distToNearest;
         double latVelToNearest;
         double advVelToNearest;
         double nearestEnergyRatio;
         double enemiesAlive;
         
         double[] treeLocation(){
            double[] weights = {6,2,2,8,8,1,8,3};
            
            return new double[]{
                  distLast10/80*weights[0],
                  distToWall/1000*weights[1],
                  distToNearest/1400*weights[2],
                  Math.abs(latVelToNearest)/8*weights[3],
                  (advVelToNearest + 8)/16*weights[4],
                  1/(1 + nearestEnergyRatio)*weights[5],
                  enemiesAlive/enemies.size()*weights[6],
                  distToCorner/1000*weights[7]};
         }
      }
   }
