   package jk.mini;

   import robocode.*;
   import robocode.util.Utils;
   import java.awt.geom.*;     // for Point2D's
   import java.lang.*;         // for Double and Integer objects
   import java.util.ArrayList; // for collection of waves
   import java.awt.*;
   import java.util.*;

    public class CunobelinDC extends AdvancedRobot {
    
      static final int GUN_BINS = 230;// full 360 degrees of bins - not just in the reachable range
      static final int MAX_MATCHES = 50;  
   	
      static ArrayList hitScans = new ArrayList();
      
      public static Point2D.Double myLocation;    
      public static Point2D.Double enemyLocation; 
   
      public static ArrayList enemyWaves;
      public static ArrayList pastWaves;
      public static EnemyWaveDC _surfWave;
   
      public static double enemyEnergy = 100.0;
   
      public static final Rectangle2D.Double fieldRect
        = new java.awt.geom.Rectangle2D.Double(18, 18, 764, 564);
      public static final double WALL_STICK = 160;
      
   	
      static StringBuilder data = new StringBuilder();
         
      static double lastLatVel;
   
       public void run() {
       
       
      	//NOT NECESSARY FOR 35 ROUND BATTLES - CAN BE REMOVED FOR 15 EXTRA CODESIZE
        //  try{
      //             data.delete(60000, 80000);
      //          }
      //              catch(Exception e){}
      
       
         enemyWaves = new ArrayList();
         pastWaves = new ArrayList();
      
         setAdjustGunForRobotTurn(true);
         setAdjustRadarForGunTurn(true);
        	
      	
         do {
            turnRadarRightRadians(Double.POSITIVE_INFINITY);
         } while (true);
      }
   
       public void onScannedRobot(ScannedRobotEvent e) {
         EnemyWaveDC ew;
         double absBearing;
         double latVel = (getVelocity()*Math.sin(absBearing = e.getBearingRadians()));
         double advVel = (getVelocity()*Math.cos(absBearing));
      	
         setTurnRadarRightRadians(Utils.normalRelativeAngle((absBearing += getHeadingRadians()) - getRadarHeadingRadians()) * 2);
        
         myLocation = new Point2D.Double(getX(), getY());
         (ew = new EnemyWaveDC()).direction = (int)Math.signum(latVel + 1E-10);
         ew.directAngle = absBearing + Math.PI;
      
         double eDistance;
         ew.scan = new double[]
            {0,(eDistance = e.getDistance())*(1/1000.0),advVel/2,lastLatVel/2, lastLatVel = Math.abs(latVel)};
            
         pastWaves.add(0,ew);
         addWave(enemyEnergy - (enemyEnergy = e.getEnergy()));
      
        // update after EnemyWave detection, because that needs the previous
        // enemy location as the source of the wave
         
         enemyLocation = project(myLocation, absBearing, eDistance);
      
         updateWaves();
         int direction = 1;
         if (checkDanger(-1) < checkDanger(1)) 
            direction = -1;
         
         double goAngle = wallSmoothing(myLocation, 
               ew.directAngle + direction*offset(eDistance),
               direction)
               - getHeadingRadians();
         
         setAhead(Math.cos(goAngle)*Double.POSITIVE_INFINITY);
         setTurnRightRadians(Math.tan(goAngle));
      
      // GUN \/  \/
         data.insert(0,(char)(((int)Math.round(e.getVelocity()*Math.sin(latVel = e.getHeadingRadians()- absBearing))<<8)|
            (0XFF&((byte)(e.getVelocity()*Math.cos(latVel))))));
         
         double bulletPower;
         setFire(bulletPower = eDistance < 150 ?3:Math.min(2,Math.min(getEnergy()/16, enemyEnergy/2)));
         
         setTurnGunRightRadians(Utils.normalRelativeAngle(absBearing + 4*(Math.random() - 0.5)/eDistance
            + 
            getGunAngle(
            Math.min(66,Math.min(data.length(), pastWaves.size()
            )),eDistance,bulletPower) - getGunHeadingRadians()));
         
      	// gun /\  /\
      
      }
       public static double getGunAngle(int keyLength, double distance, double bulletPower){
         int indexSize = 0;
         int[] index = new int[MAX_MATCHES];
         int tempIndex = 0;
         int[] bins = new int[GUN_BINS]; 
         do{
            do{
               if( tempIndex < 0 )
                  keyLength= (keyLength*3)/4;
                  // keyLength/=2;
            
               tempIndex = data.indexOf(
                  data.substring(0, keyLength),tempIndex + 2);
            
            }while((tempIndex < 0  || Arrays.binarySearch(index,tempIndex) >= 0) && keyLength > 0);	
            if(keyLength == 0)
               break;
            int iterateIndex = index[0] = tempIndex;
            Arrays.sort(index);
            
            double tempDist = distance;
            double absBearing = 0;
            double db=0;
            char comboChar;
            do{  
               absBearing += (byte)((comboChar = data.charAt(iterateIndex--))>>8)/tempDist;
               tempDist += (byte)(comboChar&0XFF);    
            }while (/*comboChar != ROUND_BREAK && */(db+=Rules.getBulletSpeed(bulletPower)) < tempDist && iterateIndex > 0);
         	
            //if(comboChar != ROUND_BREAK && iterateIndex > 0)
            bins[(int)(Utils.normalAbsoluteAngle(absBearing)*((GUN_BINS - 1)/(2*Math.PI)))]+= keyLength;
               
                     
         }while(++indexSize < MAX_MATCHES);
         
         keyLength = GUN_BINS - 1;
         tempIndex = 0;
         do{
            if(bins[keyLength] > bins[tempIndex])
               tempIndex = keyLength;
         }
         while(keyLength-- > 0);
            
         return tempIndex*(2*Math.PI/(GUN_BINS - 1));
      }  
   	
   
        	
       public static void addWave(double deltaEnergy){
         if (pastWaves.size() > 2 && deltaEnergy <= 3 && deltaEnergy > 0.009){
            EnemyWaveDC ew = (EnemyWaveDC)pastWaves.get(2);
            ew.bulletVelocity = Rules.getBulletSpeed(deltaEnergy);
            // ew.distanceTraveled = ew.bulletVelocity;
            ew.fireLocation = enemyLocation;
            enemyWaves.add(ew);
         }
      }
       public static void updateWaves() {
         double minDist = Double.NEGATIVE_INFINITY;
         _surfWave = null;
         Iterator it = enemyWaves.iterator();
         while(it.hasNext()) {
            EnemyWaveDC ew;
            double dist;
            if ((dist = ((ew = (EnemyWaveDC)it.next()).distanceTraveled += ew.bulletVelocity )
            - myLocation.distance(ew.fireLocation)) > 50) {
               it.remove();
               continue;
            }
            
            if(dist > minDist 
            && dist < -18){
               _surfWave = ew;
               minDist = dist;   
            }
         }
      }
   
   
    // Given the EnemyWave that the bullet was on, and the point where we
    // were hit, calculate the index into our stat array for that factor.
       public static double getFactor(EnemyWaveDC ew, Point2D.Double targetLocation) {
         return Utils.normalRelativeAngle(absoluteBearing(ew.fireLocation, targetLocation)  - ew.directAngle) * ew.direction
            /  Math.asin(8.0/ew.bulletVelocity);
      }
   
    // Given the EnemyWave that the bullet was on, and the point where we
    // were hit, update our stat array to reflect the danger in that area.
   
       public void onBulletHitBullet(BulletHitBulletEvent e){
         logEnemyBullet(e.getHitBullet());
      }
       public void onHitByBullet(HitByBulletEvent e) {
        
         logEnemyBullet(e.getBullet());
         enemyEnergy += 3*e.getBullet().getPower();
      }
       public void onBulletHit(BulletHitEvent e){
         enemyEnergy -= Rules.getBulletDamage(e.getBullet().getPower());
      }
       public static void logEnemyBullet(Bullet b){
               // look through the EnemyWaves, and find one that could've hit us.
         Point2D.Double hitLocation =  new Point2D.Double(b.getX(), b.getY()); 
         Iterator it = enemyWaves.iterator();
         while (it.hasNext()) {
            EnemyWaveDC ew = (EnemyWaveDC)it.next();
            
            if (Math.abs(ew.distanceTraveled - hitLocation.distance(ew.fireLocation)) <= 40
                    // && Math.abs(Rules.getBulletSpeed(b.getPower()) - ew.bulletVelocity) < 0.1
               	  ) {
               ew.scan[0] = getFactor(ew,hitLocation);
               hitScans.add(ew.scan);
                // We can remove this wave now, of course.
               it.remove();
            }
         }
      
      }
   
    // CREDIT: mini sized predictor from Apollon, by rozu
    // http://robowiki.net?Apollon
   
       public  double checkDanger(int direction) {
         Point2D.Double predictedPosition = myLocation;
         double predictedVelocity = getVelocity();
         double predictedHeading = getHeadingRadians();
         double moveAngle, moveDir;
      
         int counter = 0; // number of ticks in the future
      
         do {
            moveAngle =
                wallSmoothing(predictedPosition, absoluteBearing(enemyLocation,
                predictedPosition) + (direction * (offset(predictedPosition.distance(enemyLocation)))), direction)
                - predictedHeading;
            moveDir = 1;
         
            if(Math.cos(moveAngle) < 0) {
               moveAngle += Math.PI;
               moveDir = -1;
            }
         
            predictedPosition = project(predictedPosition,
               predictedHeading = Utils.normalRelativeAngle(
               predictedHeading
                + posNegLimit(Utils.normalRelativeAngle(moveAngle),
                 Rules.getTurnRateRadians(Math.abs(predictedVelocity)))
                )
                ,
                 predictedVelocity = posNegLimit(predictedVelocity += (predictedVelocity * moveDir < 0 ? 2*moveDir : moveDir), 8)
                 );
               
         } while(_surfWave != null && predictedPosition.distance(_surfWave.fireLocation) - 18  >
                _surfWave.distanceTraveled  + ((++counter) * _surfWave.bulletVelocity));
      
         predictedVelocity = 1;
         if(_surfWave != null){
            predictedVelocity = getDanger( getFactor(_surfWave,predictedPosition), _surfWave.scan);
         }
         
         return predictedVelocity/predictedPosition.distanceSq(enemyLocation);
      }
       final static double getDanger(double GF, double[] location){
         double danger = 0;
         Iterator i = hitScans.iterator();
         while(i.hasNext()){
            double[] scan = (double[])i.next();
            double dist = 0;
            for(int j = 1; j < location.length; j++){
               dist += Math.abs(location[j] - scan[j]);
            }
            danger += 1/dist/((1.0/50) + Math.abs(GF - scan[0]));
         }
         return danger;
      }
   
       public static double offset(double distance){
         return (Math.PI/2 - 0.4) + (0.4/475)*distance;
      }
       // public void onDeath(DeathEvent e){
         // System.out.println("!!!!LOSS!!!!!");
         // System.out.println("   myLocation: (" + myLocation.x + ";" + myLocation.y);
         // System.out.println("enemyLocation: (" + enemyLocation.x + ";" + enemyLocation.y);
      // }
   
    // This can be defined as an inner class if you want.
       static class EnemyWaveDC {
         Point2D.Double fireLocation;
         double bulletVelocity, directAngle, distanceTraveled;
         int direction;
         double[] scan;
      
      }
   
    // CREDIT: Iterative WallSmoothing by Kawigi
    //   - return absolute angle to move at after account for WallSmoothing
    // robowiki.net?WallSmoothing
       public static double wallSmoothing(Point2D.Double botLocation, double angle, int orientation) {
         do {
            angle += orientation*0.05;
         }while (!fieldRect.contains(project(botLocation, angle, WALL_STICK)));
         return angle;
      }
   
    // CREDIT: from CassiusClay, by PEZ
    //   - returns point length away from sourceLocation, at angle
    // robowiki.net?CassiusClay
       public static Point2D.Double project(Point2D.Double sourceLocation, double angle, double length) {
         return new Point2D.Double(sourceLocation.x + Math.sin(angle) * length,
            sourceLocation.y + Math.cos(angle) * length);
      }
   
    // got this from RaikoMicro, by Jamougha, but I think it's used by many authors
    //  - returns the absolute angle (in radians) from source to target points
       public static double absoluteBearing(Point2D.Double source, Point2D.Double target) {
         return Math.atan2(target.x - source.x, target.y - source.y);
      }
   
       public static double posNegLimit(double value, double max) {
         return Math.max(-max, Math.min(value, max));
      }
   
   
   /*
       public void onPaint(java.awt.Graphics2D g) {
         g.setColor(Color.red);
         for(int k = 0; k < enemyWaves.size(); k++){
            EnemyWave ew = (EnemyWave)(enemyWaves.get(k));
            int radius = (int)ew.distanceTraveled;
            double max = 0;
            for(int i = 0; i < BINS; i++){
               if(ew.bins[i] + noSegSurfStats[i]/30 > max)
                  max = ew.bins[i] + noSegSurfStats[i];
            }
            double MEA = Math.asin(8.0/ew.bulletVelocity);
            for(int i = 0; i < BINS; i++){
               double thisDanger =(ew.bins[i] + noSegSurfStats[i]/30)/max;
               g.setColor(Color.blue);
               if(thisDanger > 0.1)
                  g.setColor(Color.green);
               if(thisDanger > 0.3)
                  g.setColor(Color.yellow);
               if(thisDanger > 0.6)
                  g.setColor(Color.orange);
               if(thisDanger > 0.9)
                  g.setColor(Color.red);
               
               double angle = ew.directAngle + ew.direction*(i - CENTER_BIN)*MEA/(double)CENTER_BIN;
               Point2D.Double thisPoint = project(ew.fireLocation,angle,radius);
               g.drawOval((int)(thisPoint.x - 1),(int)(thisPoint.y - 1), 2, 2);
               if(ew == _surfWave)
                  g.drawOval((int)(thisPoint.x - 2),(int)(thisPoint.y - 2), 4, 4);
            }
         }
      }
       */  // 
   
   }
