package kawigi.nano;
import robocode.*;
import java.awt.geom.*;

public class FunkyChicken extends AdvancedRobot
{
	static StringBuffer pattern = new StringBuffer("" + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)0 + (char)-8 + (char)-7 + (char)-6 + (char)-5 + (char)-4 + (char)-3 + (char)-2 + (char)-1 + (char)1 + (char)2 + (char)3 + (char)4 + (char)5 + (char)6 + (char)7 + (char)8);
	
	public void run()
	{
		setAdjustGunForRobotTurn(true);
		turnRadarRight(Double.POSITIVE_INFINITY);
	}

	public void onScannedRobot(ScannedRobotEvent e)
	{
		//The old "Perceptual bullet-dodger" code:
		//setAhead(Math.tan(e.getEnergy()*5)*500);
		double absbearing;
		setTurnRightRadians((absbearing = e.getBearingRadians())-Math.PI/2);
		//rounding to be more accurate in projection!
		pattern.insert(0, (char)(Math.round(Math.sin(e.getHeadingRadians() - (absbearing = absbearing + getHeadingRadians()))*e.getVelocity())));
		
		int index=0, searchlength = 30;
		//lol, if I ever make a haiku pattern-matcher, this will be in it:
		while ((index = pattern.toString().indexOf(pattern.substring(0, searchlength--), 1)) < 0);
		
		//searchlength will now become the index of the StringBuffer that I will project back to (back because my pattern 
		//is stored backward).
		double power;
		double dist;
		searchlength =  index - (int)((dist = e.getDistance())/(20-(power = Math.min(3, Math.min(getEnergy(), e.getEnergy())/4))*3));
		
		//just add the offset to the bearing instead of making a new variable!
		//The fact that this actually reconstructs future movement (like a normal pattern-matcher does) probably makes this
		//just about the most accurate current nano pattern-matcher (except possibly Kakuru's, since it uses doubles instead of
		//characters).  The nice thing about it is that it correctly projects patterns even if I'm at a different distance than
		//when I collected the pattern.
		do
		{
			absbearing += Math.asin(((byte)pattern.charAt(index--))/dist);
		}
		while (index >= Math.max(0, searchlength));
		
		setTurnGunRightRadians(robocode.util.Utils.normalRelativeAngle(absbearing - getGunHeadingRadians()));
		setFire(power);
		
		//Fhqwhgads 1.0 went one direction for enemyDistance/(20-3*lastenemybulletpower)*Math.random() ticks,
		//and then picked a new direction/amount of time to move.  This is a greatly simplified version of this.
		//It may well be the 'flattest' nano profile yet created for high-powered bullets, and it works at pretty
		//much any distance.  I'm sure a REAL flat movement could be fit into a nano, but not with this complex of a gun.
		if (getDistanceRemaining() == 0)
			setAhead((Math.random()-.5)*dist*1.2);
		setTurnRadarLeft(getRadarTurnRemaining());
	}
}