package kc.melee;
import kc.melee.*;
import kc.melee.gun.*;
import kc.melee.movement.*;
import kc.melee.scanner.*;
import robocode.*;
import robocode.util.Utils;
import java.awt.Color;

/**
* Logic - A melee specialist by Kev
*/

public class Logic extends AdvancedRobot{
	static public boolean drawingGraphics = false;
	static public boolean MRMC = false;
	MeleeManager manager;
	MeleeMovement movement;
	DuelMovement duelMovement;
	MeleeGun gun;
	Scanner scanner;
	static int[] finishes;
	static int wallHits = 0;
	static int skippedTurns = 0;
	static int totalTime;
	public void run(){
		manager = new MeleeManager(this);
		movement = new MeleeMovement(this, manager);
		duelMovement = new DuelMovement(this, manager);
		gun = new MeleeGun(this, manager, MRMC);
		scanner = new Scanner(this, manager, MRMC);
		setAdjustRadarForGunTurn(true);
		setAdjustGunForRobotTurn(true);
		setColors(Color.red.darker(), Color.red.darker(), new Color(255, 255, 255));
		if(finishes == null){finishes = new int[getOthers()+1];}
		manager.init();
		movement.init();
		gun.init();
		setTurnRadarRightRadians(3 * Math.PI);
		do{
			manager.setVariables();
			gun.point();
			if(manager.currentEnemies != 1){movement.move();}
			if(manager.gameTime > 15){scanner.scan();}
			execute();
		}while(true);
	}
	public void onScannedRobot(ScannedRobotEvent e){
		manager.onScannedRobot(e);
		if(manager.currentEnemies == 1){duelMovement.onScannedRobot(e);}
		gun.onScannedRobot(e);
	}
	public void onRobotDeath(RobotDeathEvent e){
		manager.onRobotDeath(e);
	}
	public void onHitWall(HitWallEvent e){
		wallHits++;
	}
	public void onBulletHit(BulletHitEvent e){
		if(manager.currentEnemies == 1){duelMovement.onBulletHit(e);}
	}
	public void onHitByBullet(HitByBulletEvent e){
		if(manager.currentEnemies == 1){duelMovement.onHitByBullet(e);}
	}
	public void onSkippedTurn(SkippedTurnEvent e){
		skippedTurns++;
	}
	public void onWin(WinEvent e){
		setAhead(0);
		onDeath(null);
	}
	public void onDeath(DeathEvent e){
		out.println("wall hits: " + wallHits);
		scanner.onDeath(e);
		gun.onDeath(e);
		totalTime += (int)getTime();
		out.println("skipped turns: " + skippedTurns + " = " + (100 * (double)skippedTurns / (double)totalTime) + "%");
		finishes[getOthers()]++;
		for (int i=0; i< finishes.length; i++)
			out.print((i == getOthers() ? "*" : "") + finishes[i] + " ");
		out.println();
	}
	public void setTurnRadarRightRadians(double v){
		super.setTurnRadarRightRadians(v);
	}
	public void setAhead(double v){
		super.setAhead(v);
	}
	public void setTurnRightRadians(double v){
		super.setTurnRightRadians(v);
	}
	public void setMaxVelocity(double v){
		super.setMaxVelocity(v);
	}
}
