package kc.melee.gun;
import kc.melee.*;
import kc.gun.*;
import kc.melee.utils.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.geom.*;
import java.awt.Color;

/**
 * MeleeGun - Controls the shooting of Logic
 */
public class MeleeGun {
	static boolean MRMC = false;
	AdvancedRobot robot;
	MeleeManager manager;
    public MeleeGun(AdvancedRobot robot, MeleeManager manager, boolean MeleeMovementChallenge) {
		this.robot = robot;
		this.manager = manager;
		MRMC = MeleeMovementChallenge;
	}
	static final double PI = Math.PI;
	Rectangle2D hittingField;
	static int wastedTicks = 0;
	static int shots = 0;
	static final int AIM_FACTORS = 33;
	static final double SMOOTHING = 0.3;
	//enemies, bullet time, relative heading, time accel (duels only), wall ahead, wall reverse, enemies, segmentation mode, factors
	static double data[][][][][][][][][] = new double[2][5][3][4][2][2][20][1][AIM_FACTORS + 1];
	double currentData[];
	int waves = -1;
	int firstActiveWave = 0;
	int nearestWave;
	Wave[] wave = new Wave[100000];	
	public void init(){
		hittingField = KUtils.makeField(robot.getBattleFieldWidth(), robot.getBattleFieldHeight(), 20);
	}
	public void onScannedRobot(ScannedRobotEvent e){
		Enemy target = manager.findEnemy(e.getName());
		double bulletPower = findBulletPower(target, manager);
		double bulletTravelTime = target.distance / KUtils.bulletSpeed(bulletPower);
		double relativeHeading = Math.abs(Utils.normalRelativeAngle(target.heading - target.absoluteBearing));
		double timeAccel = ((double)(manager.gameTime) - (double)(target.lastReverseTime)) / bulletTravelTime;
		double wallAhead = 1;
		Point2D.Double projectedLocation;
		for(wallAhead = 0; wallAhead <= 1; wallAhead += 0.01){
			projectedLocation = KUtils.projectMotion(manager.myLocation, target.absoluteBearing + (target.clockDirection * wallAhead), target.distance);
			if(!hittingField.contains(projectedLocation)){break;}
		}
		double wallReverse = 1;
		for(wallReverse = 0; wallReverse <= 1; wallReverse += 0.01){
			projectedLocation = KUtils.projectMotion(manager.myLocation, target.absoluteBearing - (target.clockDirection * wallReverse), target.distance);
			if(!hittingField.contains(projectedLocation)){break;}
		}
		int relativeHeadingIndex = 0;
		if(manager.currentEnemies > 1){
			if(relativeHeading < PI/3){relativeHeadingIndex = 1;}
			if(relativeHeading > 2*PI/3){relativeHeadingIndex = 2;}
		}
		int timeAccelIndex = 0;
		if(manager.currentEnemies == 1){
			if(timeAccel < 0.1){timeAccelIndex = 1;}
			if(timeAccel < 0.7){timeAccelIndex = 2;}
		}
		waves++;
		wave[waves] = new Wave();
		wave[waves].active = 1;
		wave[waves].source = manager.myLocation;
		wave[waves].target = target.location;
		wave[waves].enemyClockDirection = target.clockDirection;
		wave[waves].fireTime = manager.gameTime;
		wave[waves].targetEnemy = manager.currentScannedEnemy;
		wave[waves].targetIndex = manager.getIndex(e.getName());
		wave[waves].speed = KUtils.bulletSpeed(bulletPower);
		wave[waves].weight = 1;
		wave[waves].dataNormal = data[manager.currentEnemies == 1 ? 1 : 0]
							   		 [Math.min((int)(bulletTravelTime / 13), 4)]
							   		 [relativeHeadingIndex]
							  		 [timeAccelIndex]
							  		 [wallAhead < 0.6 ? 1 : 0]
							  		 [wallReverse < 0.6 ? 1 : 0]
							  		 [wave[waves].targetIndex]
							  		 [0];	
		updateWaves();
		removeWaves(target);
		if(manager.targetEnemy().name.equals(e.getName()) && target.active == 2){
			int maximumFactor = AIM_FACTORS;
			int minimumFactor = 0;
			maximumFactor = (int)Math.round(Math.min(KUtils.middleFactor(AIM_FACTORS) * (1 + (wallAhead / KUtils.maxEscapeAngle(wave[waves].speed))), AIM_FACTORS));
			minimumFactor = (int)Math.round(Math.max(KUtils.middleFactor(AIM_FACTORS) * (1 - (wallReverse / KUtils.maxEscapeAngle(wave[waves].speed))), 0));
			currentData = wave[waves].dataNormal;
			double bestGF = KUtils.toGF(findBestAimFactor(minimumFactor, maximumFactor), AIM_FACTORS);
			double angleOffset = bestGF * KUtils.maxEscapeAngle(wave[waves].speed) * target.clockDirection;
			double gunTurn = Utils.normalRelativeAngle(target.absoluteBearing + angleOffset - robot.getGunHeadingRadians());
			robot.setTurnGunRightRadians(gunTurn);
			if((Math.abs(gunTurn) < PI/9)&&(robot.getGunHeat() == 0.0)&&(bulletPower >= 0.1)){
				robot.setFire(bulletPower);
				shots++;
			}
		}	
	}
	public void point(){
		updateWaves();
		if((manager.gameTime - manager.targetEnemy().lastScannedTime > 0 || MRMC)&&(manager.targetEnemy().active == 2)){
			robot.setTurnGunRightRadians(Utils.normalRelativeAngle(KUtils.absoluteBearing(manager.myLocation, manager.targetEnemy().location) - robot.getGunHeadingRadians()));
			if(robot.getGunHeat() == 0 && !MRMC){wastedTicks++;}
		}
		if(Math.abs(robot.getGunTurnRemainingRadians()) == 0 && robot.getGunHeat() == 9 && manager.myEnergy > 1 && MRMC){
			robot.setFire(findBulletPower(manager.targetEnemy(), manager));
		}
	}
	public static double findBulletPower(Enemy target, MeleeManager manager){
		if(MRMC){return Math.min(Math.min(manager.myEnergy / 6, 1300 / target.distance), target.energy / 3);}
		double bulletPower = (manager.currentEnemies == 1 ? 900 : (manager.currentEnemies == 3 ? 1300 : 1200)) / target.distance;
		bulletPower = Math.max(Math.min(bulletPower, target.energy / 3), 0.1);
		bulletPower = Math.min(Math.min(bulletPower, (manager.myEnergy - 3.3) / 6), 3);
		if(manager.currentEnemies == 1 && manager.myEnergy > target.energy && manager.myEnergy - bulletPower < target.energy + 0.3){bulletPower = -1;}
		return bulletPower;
	}
	int findBestAimFactor(int minimum, int maximum){
		int bestAimFactor = KUtils.middleFactor(AIM_FACTORS);
		double highestScore = 0;
		for(int i = minimum; i < maximum; i++){
			if(currentData[i] > highestScore){
				highestScore = currentData[i];
				bestAimFactor = i;
			}
		}
		return bestAimFactor;
	}
	public void updateData(double weight, int aimFactor){
		currentData[AIM_FACTORS] += weight;
		for(int i = 0; i < AIM_FACTORS; i++){
			currentData[i] += weight * Math.pow(SMOOTHING, Math.abs(i - aimFactor));
		}
	}
	public void updateWaves(){
		double smallestWaveDistance = Double.POSITIVE_INFINITY;
		double smallestActiveWaveDistance = Double.POSITIVE_INFINITY;
		for(int i = firstActiveWave; i <= waves; i++){
			if(manager.enemy[wave[i].targetEnemy].active != 2){wave[i].active = 0;}
			wave[i].distance = wave[i].source.distance(manager.enemy[wave[i].targetEnemy].location);
			wave[i].radius = (manager.gameTime - wave[i].fireTime + 1) * wave[i].speed;
			if(wave[i].distance - wave[i].radius < smallestWaveDistance){
				smallestWaveDistance = wave[i].distance - wave[i].radius;
				nearestWave = i;
			}
			if((nearestWave == firstActiveWave)&&(wave[nearestWave].active == 0)){firstActiveWave++;}
		}
	}
	public void removeWaves(Enemy bot){
		for(int i = firstActiveWave; i <= waves; i++){
			if(wave[i].active == 1 && manager.enemy[wave[i].targetEnemy].name.equals(bot.name)){
				if(wave[i].radius >= wave[i].distance){
					double xChange = (bot.lastLocation.getX() - bot.location.getX()) / Math.max(manager.gameTime - bot.lastScannedTime, 1);
					double yChange = (bot.lastLocation.getY() - bot.location.getY()) / Math.max(manager.gameTime - bot.lastScannedTime, 1);
					Point2D.Double ePosition = new Point2D.Double(bot.location.getX(), bot.location.getY());
					double eRadius = wave[i].radius;
					do{
						ePosition.x += xChange;
						ePosition.y += yChange;
						eRadius -= wave[i].speed;
					}while(ePosition.distance(wave[i].source) < eRadius);
					ePosition.x -= xChange;
					ePosition.y -= yChange;
					double angleOffset = Utils.normalRelativeAngle(KUtils.absoluteBearing(wave[i].source, ePosition) - KUtils.absoluteBearing(wave[i].source, wave[i].target));
					double GF = angleOffset / KUtils.maxEscapeAngle(wave[i].speed) * wave[i].enemyClockDirection;
					currentData = wave[i].dataNormal;
					updateData(wave[i].weight, KUtils.toFactor(GF, AIM_FACTORS));
					wave[i].active = 0;
				}
			}
		}
	}
	public void onDeath(DeathEvent e){
		System.out.println("skipped shots: " + (int)Math.round((double)(wastedTicks)/13) + " = " + (100 * (double)(wastedTicks/13) / ((double)(wastedTicks/13) + (double)(shots))) + "%");
	}
}
