package kc.melee.scanner;
import kc.melee.*;
import kc.melee.gun.*;
import kc.melee.utils.*;
import robocode.*;
import robocode.util.Utils;
import java.io.*;
import java.awt.geom.*;
import java.awt.Color;

/**
 * Scanner - Operates the radar for Logic.
 * Yes, all this code is for radar :)
 */
public class Scanner {
	static boolean MRMC = false;
	AdvancedRobot robot;
	MeleeManager manager;
    public Scanner(AdvancedRobot robot, MeleeManager manager, boolean MeleeMovementChallenge) {
		this.robot = robot;
		this.manager = manager;
		MRMC = MeleeMovementChallenge;
	}
	static int forcedSweeps;
	int currentScanTarget = -1;
	boolean lastTurnForcedSweep;
	public void scan(){
		long lowestScanTime = manager.gameTime * 2;
		int newScanTarget = 0;
		boolean locking = false;
		boolean forcedSweep = false;
		for(int i = 0; i < manager.enemies; i++) {
			if(manager.enemy[i].active == 2){
				if(manager.enemy[i].lastScannedTime < lowestScanTime){
					lowestScanTime = manager.enemy[i].lastScannedTime;
					newScanTarget = i;
				}
				if(manager.gameTime - manager.enemy[i].lastScannedTime > 25){forcedSweep = true;}
			}
		}
		int timeUntilScanTarget = (int)(Math.ceil(Math.abs(Utils.normalRelativeAngle(manager.targetEnemy().absoluteBearing - robot.getRadarHeadingRadians())))/(Math.PI/4)) + 3;
		if((timeUntilScanTarget >= (int)Math.ceil(robot.getGunHeat()*10))&&(!forcedSweep)&&(manager.myEnergy > 3)&&(!MRMC)){
			newScanTarget = manager.target;
			locking = true;
		}
		if(newScanTarget != currentScanTarget){
			robot.setTurnRadarRightRadians(Double.POSITIVE_INFINITY * KUtils.sign(Utils.normalRelativeAngle(manager.enemy[newScanTarget].absoluteBearing - robot.getRadarHeadingRadians())));
			currentScanTarget = newScanTarget;
		}
		if(manager.currentEnemies == 1){locking = true;}
		if(locking && (manager.gameTime - manager.targetEnemy().lastScannedTime == 0)){
			double radarTurn = Utils.normalRelativeAngle(manager.targetEnemy().absoluteBearing - robot.getRadarHeadingRadians());
			radarTurn += KUtils.sign(radarTurn) * Math.PI/8;
			robot.setTurnRadarRightRadians(radarTurn);
		}
		if(forcedSweep && !lastTurnForcedSweep){forcedSweeps++;}
		if(forcedSweep){lastTurnForcedSweep = true;}else{lastTurnForcedSweep = false;}
		if(robot.getRadarTurnRemaining() == 0){robot.setTurnRadarRightRadians(Double.POSITIVE_INFINITY);}
	}
	public void onDeath(DeathEvent e){
		System.out.println("forced sweeps: " + forcedSweeps);
	}
}
