package kc.melee.utils;
import robocode.util.Utils;
import java.awt.geom.*;

/**
* KUtils - A bunch of useful functions for Logic.
*/

public class KUtils {
	public static double bulletSpeed(double power){
		return 20 - (3 * power);
	}
	public static double maxEscapeAngle(double speed){
		return Math.asin(8 / speed);
	}
	public static Point2D.Double projectMotion(Point2D.Double source, double angle, double distance){
		return new Point2D.Double(source.getX() + (Math.sin(angle) * distance), source.getY() + (Math.cos(angle) * distance));
	}
	public static double absoluteBearing(Point2D.Double source, Point2D.Double target) {
        return Math.atan2(target.getX() - source.getX(), target.getY() - source.getY());
    }
	public static int sign(double v){
		return v > 0 ? 1 : -1;
	}
	public static Rectangle2D makeField(double width, double height, double margin){
		return new Rectangle2D.Double(margin, margin, width - (margin * 2), height - (margin * 2));
	}
	public static double toGF(int factor, int totalFactors){
		return (((double)(factor) / ((double)(totalFactors - 1))) * 2) - 1;
	}
	public static int toFactor(double GF, int totalFactors){
		return (int)(Math.round((GF + 1) * middleFactor(totalFactors)));
	}
	public static int middleFactor(int aimFactors){
		return (int)((aimFactors - 1) / 2);
	}
}
