package kvk.Gun;
import kvk.Bots.Bot;
import kvk.ExtendedRobot;
import robocode.*;

/**
 *  Classe abstraite pour les mthodes de vise
 *
 * @author     Ssin.le.Terrible
 * @created    3 fvrier 2004
 */
public abstract class Aim {
	public     ExtendedRobot  myBot;
	protected  String         name;                                                //nom de la mthose de tir
	protected  int            ID;                                                  //n d'identification

	public Aim(ExtendedRobot er, String _name, int _ID) {
		myBot = er;
		name = _name;
		ID = _ID;
	}

	// ***************************** METHODES D'ACCES ***************************** //
	public String getName() {
		return name;
	}

	public int getID() {
		return ID;
	}
	// **************************************************************************** //
	/**
	 *  Calcul la solution de tir
	 *
	 * @param  target     Cible du tir
	 * @param  firePower  Puissance du tir
	 * @return            solution de tir
	 */
	public abstract FireSolution calcFireSolution(Bot target, double firePower);

	/**
	 *  Dtermine s'il faut tirer
	 *
	 * @param  FS  Description of the Parameter
	 * @return     Autorisation de tir
	 */
	public abstract boolean canShoot(FireSolution FS);

	public String toString() {
		return "Mthode de tir " + name + "(" + ID + ")";
	}

}

