package kvk.Gun;
import kvk.Bots.Bot;
import kvk.ExtendedRobot;
import kvk.Utils.Fct;
import kvk.Utils.Point;
import robocode.*;

/**
 *  Mthode de vise de Nimrod 0.50
 *
 * @author     Ssin.le.Terrible
 * @created    3 fvrier 2004
 */
public class AimNimrodStyle extends Aim {

	public AimNimrodStyle(ExtendedRobot er, String _name, int _ID) {
		super(er, _name, _ID);
	}

	public FireSolution calcFireSolution(Bot target, double firePower) {
		FireSolution  FS           = null;

		if (target != null && firePower > 0d) {
			FS = new FireSolution(target.getNimrodShootTurnAngle(firePower), firePower);
		}
		//Vrifie si l'impact est dans l'arne
		Point         impactPoint  = Fct.calcXY(myBot.getCoord(), FS.getGunOffsetAngle(), target.getDistance());
		if (!impactPoint.isOnField()) {
			FS = null;
		}

		return FS;
	}

	public boolean canShoot(FireSolution FS) {
		if (FS == null) {
			return false;
		}

		double  energy     = myBot.getEnergy();
		Bot     target     = myBot.getTarget();
		double  firePower  = FS.getFirePower();

		return ((energy > 3.1d || energy - firePower > target.getEnergy()) && Math.abs(myBot.getTime() - target.getLastAddedWave() - 2.5d) < 2.4d);
	}
}

