package matt;

import java.awt.geom.Point2D;

public class AntiGravEngine {
    private double x;
    private double y;
    private double dropOff;
    private double mass;
    
    public AntiGravEngine() {
        setLocation(0,0);
        setForce(0);
    }
    
    public void setLocation(double newX, double newY){
        this.x = newX;
        this.y = newY;
    }
    
    public void setForce(double force){
        this.mass = force;
        this.dropOff = 2;
    }
    
    public void setForce(double force, double decay){
        this.mass = force;
        this.dropOff = decay;
    }
    
    public double getActingForceDist(double distance){
        return this.mass/(Math.pow(distance,this.dropOff))*-1;
    }
    
    public double getActingForcePoint(double playerX, double playerY){
        double distance = Point2D.distance(playerX,playerY,getX(),getY());
        return this.mass/(Math.pow(distance,this.dropOff));
    }
    
    public double getX(){
        return this.x;
    }
    
    public double getY(){
        return this.y;
    }
    
    public double getForce(){
        return this.mass;
    }
}