package paulk;
import robocode.*;
import java.awt.geom.*;
import java.util.*;

public class CT extends Targeting{
	Map proba;
	CT(Map s,Map l,PaulV3 r){
		super(s,l,r);
		proba=new Hashtable();
	}

	double angle(String nom){
	// Cirular Targeting
		if (!lastScanned.containsKey(nom))
			return -10000;
		ArrayList l=(ArrayList)scannedEvents.get(nom);
		if (l.size()<2){
			return -10000;
		}
		ScannedRobotEvent e=(ScannedRobotEvent)lastScanned.get(nom);
		ScannedRobotEvent ePrec=(ScannedRobotEvent)l.get(1);
		double vitesse=20-3*bot.puissance(e.getDistance());
		double angle=e.getBearingRadians()+bot.getHeadingRadians();
		double x=bot.getX()+e.getDistance()*Math.sin(angle);
		double y=bot.getY()+e.getDistance()*Math.cos(angle);
		double dOrien=e.getHeadingRadians()-ePrec.getHeadingRadians();
		double orientation=e.getHeadingRadians();
		int temps=0;
		while (bot.dedans(x,y,17.9) && vitesse*temps<Point2D.Double.distance(x,y,bot.getX(),bot.getY())){
			x+=e.getVelocity()*Math.sin(orientation);
			y+=e.getVelocity()*Math.cos(orientation);
			orientation+=dOrien;
			temps++;
		}
		return Math.atan2(x-bot.getX(),y-bot.getY());
	}
	
	void ameliore(double anglePredit,MonOnde onde,Point2D.Double vraiePos,String nom){
		double dist=onde.getPos().distance(vraiePos);
		double x=vraiePos.getX()-onde.getX();
		double y=vraiePos.getY()-onde.getY();
		double angle=Math.atan2(x,y)-anglePredit;
		double p=1.;
		if (proba.containsKey(nom))
			p=(Double)proba.get(nom);
		if (Math.abs(bot.optimise(angle*180/3.14))>180/3.14*Math.asin(18/dist)){
			p*=0.6;
		}
		else{
			p=p*0.6+0.4;
		}
		proba.put(nom,p);
	}
	double getProba(String nom){
		if (proba.containsKey(nom)){
			return (Double)proba.get(nom);
		}
		return 1.;
	}
}
