package pi.gun;

import java.util.*;
import robocode.*;
import pi.*;

public class Gun
{
double p=Math.PI;

MasterBot monRobot;
Hashtable historique;
String cibleActuelle;
boolean firePossible;


public Gun(MasterBot _monRobot,Hashtable _historique,String _cibleActuelle,boolean _firePossible)
	{
	monRobot=_monRobot;
	historique=_historique;
	cibleActuelle=_cibleActuelle;
	firePossible=_firePossible;
	}
/****************************************************************/
/********les fonctions permettant d'updater l'information********/
/****************************************************************/
			
public void GunInformationUpdate(ScannedRobotEvent e)
	{
	String ennemi=e.getName();
	double time=e.getTime();
	double bearing=e.getBearingRadians();
	double distance=e.getDistance();
	double energy=e.getEnergy();
	Point mes_coordonnes=new Point(monRobot.getX(),monRobot.getY());
	double angle_absolu=conversion_en_angle_absolu(bearing);
	Point positionEnnemi=Point.coordonnees_actuelle_absolues_ennemi(mes_coordonnes,distance,angle_absolu);
	
	if(historique.containsKey(ennemi))/*actualisation*/
		{
		EnemyData Enemy=(EnemyData)historique.get(ennemi);
		double enemyBearing = angle_180(bearing +monRobot.getHeadingRadians());
		double enemyX = e.getDistance() * Math.sin(enemyBearing) + monRobot.getX();
		double enemyY = e.getDistance() * Math.cos(enemyBearing) + monRobot.getY();
		Enemy.updateInfo(time, enemyX, enemyY, enemyBearing,distance,energy);		
		}
			
	else/*ajout ennemi*/
		{
		historique.put(ennemi,new EnemyData());
		}
	}

public void GunEnnemiDeathUpdate(RobotDeathEvent e)
	{
	historique.remove(e.getName());
	}	


				

	

	

										
/****************************************************************/
/************la fonction qui actionne le tir: *******************/
/************1->puissance de tir	*****************************/
/************2->point d'impact prdit	*************************/
/************3->angle correspondant dont il faut tourner le gun */
/************4->tir du gun  *************************************/
/****************************************************************/

public void doGun(String ennemi)
	{
	if(ennemi!=null)
		{	
		EnemyData Enemy=(EnemyData)historique.get(ennemi);	
		double puis=puissanceDeTir(ennemi);
		double gunAim = Enemy.bearing;
		if ((monRobot.getGunHeat() / monRobot.getGunCoolingRate()) < 3)
		gunAim = Enemy.predictAngle(monRobot.getX(), monRobot.getY(),puis, monRobot.getTime());

		monRobot.setTurnGunRightRadians(angle_180(gunAim - monRobot.getGunHeadingRadians()));
		if (Math.abs(monRobot.getGunTurnRemaining()) < 10  && monRobot.getEnergy()>0.5) 
			{
			monRobot.setFire(puis);
			firePossible=false;	
			}	
		}
	}
	

																	
																																	
/****************************************************************/
/************la fonction qui dternmine la puissance du tir******/
/****************************************************************/

public double puissanceDeTir(String ennemi)
	{
	if( ennemi!=null)
		{
		if(historique!=null && historique.containsKey(ennemi))
			{
			EnemyData Enemy=(EnemyData)historique.get(ennemi);
			double ener=Enemy.energy;
	
			if(ener>16)
				{
				if(monRobot.getEnergy()>3 )	
					{
					firePossible=true;
					return 3;
					}
				else if(monRobot.getEnergy()>1 )
					{
					firePossible=true;
					 return 1;			
					}
				else 
					{
					firePossible=false;
					return 0.1;	
					}
				}
		
			else if(ener<16 && ener>0)/*ennemi faible*/
				{
				if(monRobot.getEnergy()>3 )	
					{
					firePossible=true;
					if(ener>4) return (ener+2)/6;
					else return ener/4;
					}
				else if(monRobot.getEnergy()>1)	
					{
					firePossible=true;
					return 0.1;
					}
				else 
					{
					firePossible=false;
					return 0;	
					}	
				}	
			else /*ennemi disabled*/
				{
				if(monRobot.getEnergy()>0.1)
					{
					firePossible=true;		
					return 0.1;
					}
				else return 0;
				}
			}
		else return 0;	
		}	
	else return 0;
	}
		
	
/****************************************************************/	
/*********************fonctions utilitaires**********************/
/****************************************************************/
	
public double conversion_en_angle_absolu(double angle_robot_bearing_ennemi)
		{
		double dir_abs_robot=monRobot.getHeadingRadians();
		if(angle_robot_bearing_ennemi+dir_abs_robot<2*p) return dir_abs_robot+angle_robot_bearing_ennemi;
		else return dir_abs_robot+angle_robot_bearing_ennemi-2*p;
		}	

public void moveTo(double angle)
	{
	double r=monRobot.getGunHeadingRadians();
	if(r<angle)
		{
		if(angle-r<p) monRobot.setTurnGunRightRadians(angle-r);
		else monRobot.setTurnGunLeftRadians(2*p-angle+r);	
		}
	else
		{
		if(r-angle<p)	monRobot.setTurnGunLeftRadians(r-angle);
		else			monRobot.setTurnGunRightRadians(2*p-r+angle);
		}
	}		

public double angleToMove(double angle)
	{
	double r=monRobot.getGunHeadingRadians();
	if(r<angle)
		{
		if(angle-r<p) return angle-r;
		else return 2*p-angle+r;	
		}
	else
		{
		if(r-angle<p)	return r-angle;
		else			return 2*p-r+angle;
		}
	}
public  double angle_180(double ang)
	{
	return Math.atan2(Math.sin(ang), Math.cos(ang));
	}	


}
																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																
																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																