package pi.mouvement;

import robocode.*;
import pi.*;
import java.util.*;

public class MouvementDone extends Condition implements MesConditions
{
MasterBot monRobot;
long timeMovement;
	
public 	MouvementDone(MasterBot _monRobot,long _timeMovement)
	{		
	monRobot=_monRobot;	
	timeMovement=_timeMovement;	
	}
	
public boolean test()
	{
	if(monRobot.getTime() > timeMovement)
		{
		monRobot.removeCustomEvent(this);
		return true;
		}
	else return false;
	}
	
public void handleEvent()
	{
	//System.out.println("changement"+timeMovement);
	MouvementMode temp=selectionMode(monRobot.monMouvement.informations);
	if(MouvementMode.compareMode(temp,monRobot.monMouvement.actuel)) {/*System.out.println("changement");*/monRobot.monMouvement.actuel=temp;}
		
	if(monRobot.monMouvement.actuel instanceof Oscillatoire)
		{ 
			double alea=Math.random();
				if(monRobot.monMouvement.actuel.etat==1)/*avance*/
					{
					if(alea<=0.2) monRobot.monMouvement.actuel.etat=5;//0.2
					else if(alea>0.2 && alea<0.4 ) monRobot.monMouvement.actuel.etat=3;//0.2 0.5
					else monRobot.monMouvement.actuel.etat=4;//1
					}	
				else if(monRobot.monMouvement.actuel.etat==2)/*recule*/ 
					{
					if(alea<=0.2) monRobot.monMouvement.actuel.etat=4;//1
					else if(alea>0.2 && alea<0.4 ) monRobot.monMouvement.actuel.etat=3;
					else monRobot.monMouvement.actuel.etat=5;//2
					}
				else if(monRobot.monMouvement.actuel.etat==3) /*tremble*/
					{
					if(alea<0.5) monRobot.monMouvement.actuel.etat=1;
					else monRobot.monMouvement.actuel.etat=2;
					}
				else if(monRobot.monMouvement.actuel.etat==4) /*tremble peu*/
					{
					monRobot.monMouvement.actuel.etat=1;
					}	
				else if(monRobot.monMouvement.actuel.etat==5) /*tremble peu*/
					{
					monRobot.monMouvement.actuel.etat=2;
					}
				
				if(monRobot.getTime()<50 || (monRobot.getTime()>100 && monRobot.getTime()<150) ||
				 (monRobot.getTime()>200 && monRobot.getTime()<250) || (monRobot.getTime()>300 && monRobot.getTime()<350) )	
					{
					if(monRobot.monMouvement.actuel.etat==1 ||monRobot.monMouvement.actuel.etat==2)
						{
						if(alea>0.7 && alea<=0.8) monRobot.setMaxVelocity(7);
						else if (alea>0.8 && alea<=0.9) monRobot.setMaxVelocity(6);
						else monRobot.setMaxVelocity(5);
						}
					else monRobot.setMaxVelocity(8);	
					}
				else monRobot.setMaxVelocity(8);
				
				if(monRobot.monMouvement.actuel.etat==1 ||monRobot.monMouvement.actuel.etat==2) timeMovement=timeMovement+16;
				else if(monRobot.monMouvement.actuel.etat==4 ||monRobot.monMouvement.actuel.etat==5) timeMovement=timeMovement+2;
				else timeMovement=timeMovement+6;
		}
	if(monRobot.monMouvement.actuel instanceof Defensif || monRobot.monMouvement.actuel instanceof Agressif) timeMovement=timeMovement+5;
	else if(monRobot.monMouvement.actuel instanceof EviterMurs) timeMovement=timeMovement+5;
	else timeMovement=timeMovement+5;
	
	
	monRobot.addCustomEvent(new MouvementDone(monRobot,timeMovement));
	monRobot.monMouvement.UseMouvement();		
	}
	
public MouvementMode  selectionMode(Vector informations)
	{
	double xmax=monRobot.getBattleFieldWidth();	
	double ymax=monRobot.getBattleFieldHeight();
	Point act=new Point(monRobot.getX(),monRobot.getY());
	
	if(monRobot.getTime()<22)return new EviterMurs(monRobot,informations);
	else
		{
	
	if(Point.is_not_in_area_forbiden(xmax,ymax,act))/*on est loin des murs*/
		{	
		if(informations!=null && informations.size()==1) /*1V1*/
			{
			double em=monRobot.getEnergy();
			double en=((Informations)informations.elementAt(0)).energy;
			if((en<1 && (em-en>5)) || (en<2 && (em-en>10)) || (en<3 && (em-en>20)) || (em-en>50) )
			return new Agressif(monRobot,informations);
			else
				{
				if( ((Informations)informations.elementAt(0)).distance<300 ) 
				return new Defensif(monRobot,informations);	
				else 
					{
					if(MasterBot.choixMouvement==0)
						{
						double alea=Math.random();	
						if(alea<0.5) return new Oscillatoire(monRobot,informations,1);
						else return new Oscillatoire(monRobot,informations,2);
						}
					if(MasterBot.choixMouvement==1)
						{
						return new Dodge(monRobot,informations,0);	
						}
					if(MasterBot.choixMouvement==2)
						{
						return new DodgeBis(monRobot,informations,0);	
						}
					else
						{
						return new OscillatoireBis(monRobot,informations);	
						}
					}	
				}	
			}
		else return new Defensif(monRobot,informations); /*melee*/
		
		}
	else return new EviterMurs(monRobot,informations);	/*on doit s'carter des murs*/	
	}
	}
}


		
		