package sp.Micros;
import robocode.*;
import java.awt.*;
import java.awt.geom.*;
 
public class WallAvoider extends AdvancedRobot {
	int scannedX = Integer.MIN_VALUE;
	int scannedY = Integer.MIN_VALUE;	
	int myX = Integer.MIN_VALUE;
	int myY = Integer.MIN_VALUE;		
	int moveDirection = 1;
	int turnDirection = 1;

	double bulletPower = 3;;
	double previousMovement = 0;
	double previousEnergy = 100;
	public double wallStick = 120;
 
	/**
	 * run: SuperCrazy's main run function
	 */
	public void run() {
		/* Set some crazy colors! */
		setBodyColor(new Color(167,250,145));
		setGunColor(new Color(167,250,145));
		setRadarColor(new Color(167,250,145));
		setBulletColor(new Color(167,250,145));
		setScanColor(new Color(167,250,145));
 
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
 
		while (true) {
			if (getRadarTurnRemaining() == 0.0)
            	setTurnRadarRightRadians(Double.POSITIVE_INFINITY);
	        execute();
		}
	}
 
	public void onScannedRobot(ScannedRobotEvent e) {
		if (Math.random() > 0.96) {
			moveDirection *= -1;
		}
		double totalBearing = e.getBearing();
		if (moveDirection == -1) {
			totalBearing += 180;
		}
		if (totalBearing > 360) {
			totalBearing -= 360;
		}
		if (totalBearing < 45) {
			moveDirection *= -1;
		}
		double absoluteBearing = e.getBearingRadians() + getHeadingRadians();
		double latVel= e.getVelocity()  * Math.sin(e.getHeadingRadians() - absoluteBearing);
		double gunTurn;
		double goalDirection = e.getBearing() - 90;
	

		setTurnRadarRightRadians(robocode.util.Utils.normalRelativeAngle(absoluteBearing-getRadarHeadingRadians()));
		setTurnRightRadians(getWallSmoothedTurn(Math.toRadians(goalDirection)));
		setAhead(100 * moveDirection);
		if (getGunHeat() == 0) {	
			fire(bulletPower);
		}
		
		if (e.getEnergy() < 3 && getEnergy() > e.getEnergy()) {
			bulletPower = .1;
		}
		if (getEnergy() < 3) {
			bulletPower = .1;
		}
		if (e.getDistance() >= 400) {
			gunTurn = robocode.util.Utils.normalRelativeAngle(absoluteBearing - getGunHeadingRadians()) + latVel/22;
			setTurnGunRightRadians(gunTurn);
		} else {
			gunTurn = robocode.util.Utils.normalRelativeAngle(absoluteBearing - getGunHeadingRadians()) + latVel/15;
			setTurnGunRightRadians(gunTurn);
		}
	}
 
	public double getWallSmoothedTurn(double t) {
		double wSD = 20; //wall smooth distance
		double turn = t;
	    double predictiveDistance = 200;

		double ourHeading = getHeadingRadians();
		if (moveDirection == -1) {
			ourHeading += Math.PI;
		}
		Rectangle2D.Double bounds = new Rectangle2D.Double(wSD, wSD, getBattleFieldWidth() - 2 * wSD, getBattleFieldHeight() - 2 * wSD);
				
	    double counter = 0;
		
		while (true) {
			counter++;
			double totalTurn = turn + ourHeading;
			double dXTravel = Math.sin(totalTurn) * predictiveDistance;
			double dYTravel = Math.cos(totalTurn) * predictiveDistance;
			double finishX = getX() + dXTravel;
			double finishY = getY() + dYTravel;

			if (bounds.contains(finishX, finishY)) {
				return (turn);
			} else {
				turn += 0.1 * moveDirection;
			}

			//if (counter > 500) {
			//	return turn;
			//}
		}
	}	

	public void onHitWall(HitWallEvent e) {
		moveDirection = -moveDirection;
		//setAhead(99 * moveDirection);
		out.println("I hit a wall");
	}
	
}