package sp.Nanos;
import robocode.*;
import java.awt.Color;
import robocode.util.Utils;

// API help : http://robocode.sourceforge.net/docs/robocode/robocode/Robot.html

public class CopyMachine extends AdvancedRobot{
	double firePower = 1.72;
	
	/**y
	 * run: Hollow's default behavior
	 */
	public void run() {
		// Initialization of the robot should be put here
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		// Robot main loop
		while(true) {
			// Replace the next 4 lines with any behavior you would like
			turnRadarRight(360);
		}
	}

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		double radarTurn = Utils.normalRelativeAngle(getHeadingRadians() + e.getBearingRadians() - getRadarHeadingRadians());
		setTurnRadarRightRadians(radarTurn);
		
		double gunTurn = Utils.normalRelativeAngle(getHeadingRadians() + e.getBearingRadians() - getGunHeadingRadians());
		setTurnGunRightRadians(gunTurn + getPredictiveShotAngle(e));

		setTurnRightRadians(Utils.normalRelativeAngle(e.getHeadingRadians() - getHeadingRadians()));
		setAhead(e.getVelocity() * 1.7);
		fire(firePower);
	}
	public double getPredictiveShotAngle(ScannedRobotEvent e) {
		double bVel = 20 - 3 * firePower;
		double absoluteBearing = getHeadingRadians() + e.getBearingRadians();
		double gunTurn = Utils.normalRelativeAngle(e.getVelocity() * Math.sin(e.getHeadingRadians() - absoluteBearing) / bVel);
		return (gunTurn);
	}
}