package stelo;

import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.*;

import robocode.*;
import robocode.util.Utils;

public class SteloTestNano extends AdvancedRobot {
	//private static Vector logDistance = new Vector();
	//private static double lastEnemyHeading = 0;
	private static double moveAmount = 50;
//	private static double enemyEnergy;
	//private static double lastEnemyAbsoluteBearing = 0;
	private static final int LOG_SIZE = 40;
	private static double[] velocities = new double[LOG_SIZE];
	private static int cursor;
//	private static int velocities_size;
	private static int moveTimer;
	private static double averageVelocity;
	
	public void run() {
		setAdjustGunForRobotTurn(true);
		//setAdjustRadarForGunTurn(true);

		//do {
			turnRadarRightRadians(Double.POSITIVE_INFINITY);
		//} while (true);
	}

	public void onScannedRobot(ScannedRobotEvent e) {
		double bearing = e.getBearingRadians() ;
		double absbearing = bearing + getHeadingRadians();
		setTurnRightRadians(Math.cos(bearing));
				
		//setTurnRadarRightRadians(Utils.normalRelativeAngle(absbearing - getRadarHeadingRadians()) * 2); // 2 original
//		out.println(e.getVelocity() + " " + getTime());
		setTurnRadarLeftRadians(getRadarTurnRemainingRadians());
		
//		velocities[cursor = (cursor + 1) % LOG_SIZE] = e.getVelocity();
		
//		if (velocities_size < LOG_SIZE)
//			velocities_size++;
//		double averageVelocityMini = 0;
/*
		averageVelocity = 0;
		for (int i = 0; i < LOG_SIZE; i++) {
			averageVelocity += velocities[i];
		}
*/	
		averageVelocity += e.getVelocity() - velocities[cursor = (cursor + 1) % LOG_SIZE];
		velocities[cursor] = e.getVelocity();
//		averageVelocity /= LOG_SIZE;
//		averageVelocityMini /= 8;

		//double bulletPower = Math.min(getEnergy() - 1, e.getEnergy() / 4.0);
	
		//bulletPower = limit(0.1, bulletPower, 3.0);
		//bulletPower = limit(0.1, bulletPower, (e.getDistance() < 100) ? 3.0 : 1.8);
	
		/*
		double minDiff = Double.POSITIVE_INFINITY;
		int index = 0;
		for (int i = bulletTravelTime; i < logBearing.size() - bulletTravelTime; i++) {
			double cur = Utils.normalRelativeAngle( ((Double) logBearing.elementAt(i)).doubleValue() - ((Double) logBearing.elementAt(i - bulletTravelTime)).doubleValue() );
			double diff = Math.abs(cur - bearingChange);
			if (diff < minDiff) {
				minDiff = diff;
				index = i;
			}
		}
		if (index + bulletTravelTime < logBearing.size() ) {
			bearingChange = Utils.normalRelativeAngle( ((Double) logBearing.elementAt(index + bulletTravelTime)).doubleValue() - ((Double) logBearing.elementAt(index)).doubleValue() );
		}
		*/
	
		//out.println(bearingChange);
		//out.println(bulletTravelTime);
		//setTurnGunRightRadians(	Utils.normalRelativeAngle(absbearing + bearingChange / 2 - getGunHeadingRadians()) );
		// LinearTargeting for Nanobots
		//setTurnGunRightRadians(Utils.normalRelativeAngle(absbearing - getGunHeadingRadians() + e.getVelocity() / 11.0 * Math.sin(e.getHeadingRadians() - absbearing)));
		//if (Math.random() < 0.5)
		//setTurnGunRightRadians(Utils.normalRelativeAngle(absbearing - getGunHeadingRadians() + e.getVelocity() * Math.random() / 11.0 * Math.sin(e.getHeadingRadians() - absbearing)));
		
		/*
		setTurnGunRightRadians(
			Utils.normalRelativeAngle(
				//absbearing - getGunHeadingRadians() + (e.getEnergy() == 0 ? 0.0 : Math.random() - 0.5) * 2 * Math.asin(8.0 / (20.0 - 3.0 * 3) ) 
				absbearing - getGunHeadingRadians() + (e.getEnergy() == 0 ? 0.0 : Math.random() - 0.5) * (2.0 * 0.81433994212652530966355998541367)
				//absbearing - getGunHeadingRadians() + (e.getEnergy() == 0 ? 0.0 : Math.random() - 0.5) * (2.0 * 0.60824557891020961807986752264699) // bulletPower 2
				//absbearing - getGunHeadingRadians() + (e.getEnergy() == 0 ? 0.0 : Math.random() - 0.5) * (2.0 * 0.05)
																
			) 
		);
		*/
		//setTurnGunRightRadians(Utils.normalRelativeAngle(absbearing - getGunHeadingRadians() + (Math.random() * 14.0 - 6.0)* Math.signum(e.getVelocity() ) / 11.0 * Math.sin(e.getHeadingRadians() - absbearing)));
		setTurnGunRightRadians(Utils.normalRelativeAngle(absbearing - getGunHeadingRadians() + averageVelocity  / (11.0 * LOG_SIZE) * Math.sin(e.getHeadingRadians() - absbearing)));
				
																										
		//setFire(bulletPower);
		//if (getGunTurnRemaining() == 0)
			setFire(e.getEnergy() / 4.0);
		
		//out.println("cursor: " + cursor);
//		{
			//logVelocity.append( (char) ((int) (e.getVelocity() + 8) ) );
		//	logBearing.add(new Double(absbearing ) );
			//logDistance.add(new Double(e.getDistance() ) );
//		}
		//lastEnemyHeading = e.getHeadingRadians();
		//lastEnemyVelocity = e.getVelocity();
		
		// move
		//setTurnRightRadians((e.getHeadingRadians() - getHeadingRadians()));
		//setTurnRightRadians(Utils.normalRelativeAngle( absbearing - getHeadingRadians() - Math.PI / 2 ) );
				
		//setAhead(e.getVelocity() * -5);
		setAhead(moveAmount);
		
//		if (Math.random() < 0.05)
//			moveAmount = -moveAmount;
			
		if (--moveTimer < 0 || !(new Rectangle2D.Double(18, 18, 800-36, 600-36)).contains(Math.sin(absbearing = getHeadingRadians())*moveAmount + getX(),Math.cos(absbearing)*moveAmount + getY())) {
//			if (moveTimer >= 0 || Math.random() < 0.5)
			moveAmount = -moveAmount;
			moveTimer = (int) (Math.random() * e.getDistance() / (11.0 / 2.0));
		}
		
//		if (enemyEnergy > (enemyEnergy = e.getEnergy() ) ) {
//			setMaxVelocity( Math.random() * 30.0 + 2.0);
//			if (Math.random() < 0.25)
//				onHitWall(null);
//		}
		//lastEnemyAbsoluteBearing = absbearing;
						
	}

//	public static double limit(double min, double value, double max) {
//		return Math.max(min, Math.min(value, max));
//	}

//	public void onHitWall(HitWallEvent e) {
//		moveAmount = -moveAmount;
//	}

}
																																																						