package tjk.offense;
import robocode.util.Utils;
import tjk.universe.Wave;
import tjk.universe.BracketHist;

/**
 * TargetAngle - a traget angle range (absolute angles)
 * Copyright (c) 2012 Tom Kiesel (Tkiesel @ Robowiki)
 * 
 * This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:
 * 
 *     1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. 
 *        If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.
 * 
 *     2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
 * 
 *     3. This notice may not be removed or altered from any source distribution.
 * 
 */

public class TargetAngle
{
	
	public final double angle;
	
	public TargetAngle(double in)
	{
		this.angle = in;
	}
	
	public TargetAngle(BracketHist h, Wave w )
	{
		this.angle = Utils.normalAbsoluteAngle( w.GFToAbs(h.maxAngle()) );
	}
	
}
