package tobe.statistics;
import tobe.util.BearingVector;

public class Delta extends BearingVector {

	public double turned;//not good practice
	public boolean fired = false;//not good practice
	
	Delta(BearingVector pos, BearingVector mov, BearingVector prevPos, BearingVector prevMov, double time) {
		super();
		setDifference(pos, prevPos);//what did he move
		double angularVelocity = normalizeAngle(getAbsoluteBearing() - prevMov.getAbsoluteBearing())/time;
		double velocity = getAbsoluteDistance()/time;
		setBearing(angularVelocity);
		setDistance(velocity);
		turned = normalizeAngle(mov.getAbsoluteBearing() - prevMov.getAbsoluteBearing())/time;
		//for now I don't bother about velocity changes
	}
	
	public void applyTo(BearingVector pos, BearingVector mov) {
		//when I care about velocity, change this to take it into account
		pos.add(mov.getAbsoluteBearing()+getBearing(), getDistance());
		mov.setAbsoluteBearing(mov.getAbsoluteBearing()+turned);
		//for now I don't bother about velocity changes
	}
	
	public double closeness(Delta d) {
		//when I start caring about velocity I might check patterns based on current velocity
		//so that I can find patterns with just a velocity difference (i.e. maximum/half turn)
		//now I just base comparison on the possible maximum
		double a = Math.abs(d.turned-turned)/Math.toRadians(10);
		double v = Math.abs(d.getDistance() - getDistance())/8;
		return (a+v)/2;//this seems logical, don't know why
	}
}
