package tzu.intel;

import robocode.*;
import tzu.util.*;

/**
 * Defines an interface for dealing with enemy robot management.
 * This allows us to use different enemy managers without having to
 * extend and override all over the place.
 */
public interface EnemyManagerInterface {

    public void update(ScannedRobotEvent e);
    public void updateDead(String name);
    public Point calcAntiGravity();
    public int size();
    public Bot get(int index);
    public Bot get(String name);
}
