package xander.core.paint;

/**
 * Manages data for the CPU Utilization graph.
 * 
 * @author Scott Arnold
 */
public class CPUUtilizationGraphData extends GraphData {

	public static final String PAINTER_NAME = "CPU Utilization";
	
	private long startTurnTime;
	
	public CPUUtilizationGraphData(int numDataPoints) {
		super(PAINTER_NAME, numDataPoints);
	}

	@Override
	public String getYAxisLabel() {
		return "ms";
	}

	@Override
	public String getXAxisLabel() {
		return "Time";
	}
	
	public void onTurnBegin() {
		this.startTurnTime = System.nanoTime();
	}
	
	public void onTurnEnd() {
		long turnTime = System.nanoTime() - this.startTurnTime;
		setRolledDataPoint(turnTime/1000000d);
		rollStartIndex();
	}
}
