package xander.gfws.data;

import java.util.List;

public interface KDTreeAdapter<T> {

	public int size();
	
	public SearchResult<T> searchByKNN(double[] key, int n);
	
	public List<T> searchByDistance(double[] key, double distance);
	
	public List<T> searchByRange(double[] lowerBounds, double[] upperBounds);
	
	public void addPoint(double[] key, T point);
}
