package xander.gfws.data;

import java.util.LinkedList;
import java.util.List;

/**
 * Added as a means to return search metadata along with the search results.
 * 
 * @author Scott Arnold
 *
 * @param <T>   type of data stored in the tree
 */
public class SearchResult<T> {

	private List<T> resultList;
	private double maxDistance = Double.MAX_VALUE;
	
	public SearchResult() {
		this.resultList = new LinkedList<T>();
	}
	
	public SearchResult(List<T> resultList, double maxDistance) {
		this.resultList = resultList;
		this.maxDistance = maxDistance;
	}

	public List<T> getResultList() {
		return resultList;
	}

	public double getMaxDistance() {
		return maxDistance;
	}
}
