package apv.test;
import robocode.*;
import java.awt.geom.*;
import java.util.*;

//import java.awt.Color;

/** Virus - by Albert Prez (and - probably unwilling - Jamougha :-)) 
* v 0.5 - First released version
*	 	  
*	 	  First of all, I have to give special thanks to Jamougha for Raiko. 
*		  This bot is (literally) built on top of it, so half of the bot (that's all the movement)
*		  is from him.
*
*		  This bot is primarily experiment (how to reuse a bot without knowing about it). It is released
*		  under RWPCL license (see http://www.robowiki.net/cgi-bin/robowiki?RWPCL)	
*
*		  The name makes clear the idea of the bot. It's built on top of Raiko. Like a virus, it would not
*		  live if there were not a host for it...
*
*		  The gun is just an Statistical gun. It uses a kind of symbolic segmentation and calculates the 
*		  factors on the fly. Right now probably the only advantage of it is that consumes more processor time than
*		  a "normal" one and slows down the battles... but in theory the design is very flexible, so it should not 
*		  de difficult to create a dinamically segmented gun from it (pe. removing the last character).
*
* v 0.6 - Added new segmentation criteria, including redundant distance segmentation
* v 0.6.1 - Added bearing segmentation
*  
*/		  


public class Virus extends jam.RaikoMX {

	static double direction = 1;	
		
	static double power;
	
	static double eGetDistance;
	static double targetBearing;
	static double eEnergy;
	static double eLastVelocity; //absolute
	static double eAcceleration; 
	static double eLastReversal;
	static double bestPoint;
	static double lastKnownBearing;
	
	static Point2D.Double enemyFiredFrom = new Point2D.Double();
	static Point2D.Double iWasAt = new Point2D.Double();

	static WaveProbability meW = new WaveProbability();
	
	static double bulletVelocity = 2;
	
	public void run() {
								
		setAdjustRadarForGunTurn(true); setAdjustGunForRobotTurn(true); 
		power = 2; eEnergy = 100; eLastReversal = 0; bestPoint = 0;	lastKnownBearing = 0;
		super.run();
	}
	
	public void onScannedRobot(ScannedRobotEvent e) {
		super.onScannedRobot(e);
		//ENEMY FIRED
		boolean enemyFired;	
		if (e.getEnergy()+0.09<eEnergy) enemyFired = true; else enemyFired = false;
		if (enemyFired) { //PROBABLY IT FIRED
			bulletVelocity = 20 - 3 * (eEnergy-e.getEnergy());
		}
		//UPDATE STATS FOR NEXT SURF
		targetBearing=e.getBearingRadians() + getHeadingRadians();
		eEnergy = e.getEnergy();
		eGetDistance = e.getDistance();
		eAcceleration = Math.round(Math.abs(e.getVelocity()) - eLastVelocity);
		if (e.getVelocity() == 0 || e.getVelocity() * eLastVelocity < 0) eLastReversal = 0; else eLastReversal++;
		eLastVelocity = Math.abs(e.getVelocity());
		
		//UPDATE ME AND ENEMY POSITIONS
		enemyFiredFrom.setLocation(getX()+Math.sin(targetBearing)*eGetDistance, getY()+Math.cos(targetBearing)*eGetDistance);	
		iWasAt.setLocation(getX(),getY());
		
		//UPDATE WAVES FOR AIMING
		meW.updateProbability(enemyFiredFrom, getTime());

		//AIM
		Point2D eB = meW.getLastBearing(); if (eB != null) lastKnownBearing = eB.getY(); 
		double eDirection = enemyDirection(targetBearing, e.getHeadingRadians(), e.getVelocity());
		String eSegment = getSegment(eGetDistance, e.getVelocity(), eAcceleration, eLastReversal, lastKnownBearing);
		bestPoint = meW.getBestFactor(0, 2000, eDirection, eSegment); 
				
		setTurnGunRightRadians(Math.asin(Math.sin(bestPoint+targetBearing-getGunHeadingRadians())));
			
		//ADD WAVES FOR AIMING
		if (e.getEnergy()>0) meW.addWave(iWasAt, enemyFiredFrom, power, getTime(), eGetDistance, enemyDirection(targetBearing, e.getHeadingRadians(), e.getVelocity()), eSegment);
					
	}		
		
	private double enemyDirection(double targetBearing, double targetHeading, double targetVelocity) { //1 if clockwise, -1 if anti-clockwise	
		return (targetVelocity * Math.sin(targetHeading-targetBearing) >= 0 ? 1 : -1);	
	}
			
	public void onBulletHit(BulletHitEvent e) {	eEnergy = e.getEnergy(); super.onBulletHit(e); }
		
	public void onDeath(DeathEvent e) { meW.newRound(); super.onDeath(e); }
		
	public void onWin(WinEvent e) { meW.newRound(); super.onWin(e); }	
		
	private String getSegment(double distance, double velocity, double acceleration, double lastReversal, double lastBearing) { 
		StringBuffer s = new StringBuffer();
		s.append(  (char) ((int) Math.abs(Math.round(distance/100)))  ); //!!!!!!!!!!!!!
		s.append(  (char) ((int) Math.abs(Math.round(distance/50)))  ); 
		s.append(  (char) ((int) Math.round((lastBearing+1)*5/1))  );
		s.append(  (char) ((int) Math.abs(Math.round(velocity)))  ); 
		s.append(  (char) ((int) Math.round(acceleration)) );
		s.append(  (char) ((int) Math.round(Math.min(lastReversal/12.0,9)))  );
		//out.println(Math.round((lastBearing+1)*5/1));
		return s.toString();
	}
		
		
}

																					